## volview 3.4

=== VolViewApplications/CMakeLists.txt ===
##=========================================================================
## 
##   Copyright (c) Kitware, Inc.
##   All rights reserved.
##   See Copyright.txt or http://www.kitware.com/VolViewCopyright.htm for details.
## 
##      This software is distributed WITHOUT ANY WARRANTY; without even
##      the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##      PURPOSE.  See the above copyright notice for more information.
## 
##=========================================================================
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(VolViewApplications)

# Output paths

IF(NOT LIBRARY_OUTPUT_PATH)
  SET(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)

IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)

# Install paths

IF(NOT ${PROJECT_NAME}_INSTALL_BIN_DIR)
  SET(${PROJECT_NAME}_INSTALL_BIN_DIR "/bin")
ENDIF(NOT ${PROJECT_NAME}_INSTALL_BIN_DIR)

IF(NOT ${PROJECT_NAME}_INSTALL_LIB_DIR)
  SET(${PROJECT_NAME}_INSTALL_LIB_DIR "/lib/${PROJECT_NAME}")
ENDIF(NOT ${PROJECT_NAME}_INSTALL_LIB_DIR)

IF(NOT ${PROJECT_NAME}_INSTALL_DATA_DIR)
  SET(${PROJECT_NAME}_INSTALL_DATA_DIR "/share/${PROJECT_NAME}")
ENDIF(NOT ${PROJECT_NAME}_INSTALL_DATA_DIR)

IF(NOT ${PROJECT_NAME}_INSTALL_INCLUDE_DIR)
  SET(${PROJECT_NAME}_INSTALL_INCLUDE_DIR "/include/${PROJECT_NAME}")
ENDIF(NOT ${PROJECT_NAME}_INSTALL_INCLUDE_DIR)

IF(NOT ${PROJECT_NAME}_INSTALL_PACKAGE_DIR)
  SET(${PROJECT_NAME}_INSTALL_PACKAGE_DIR ${${PROJECT_NAME}_INSTALL_LIB_DIR})
ENDIF(NOT ${PROJECT_NAME}_INSTALL_PACKAGE_DIR)

IF(NOT ${PROJECT_NAME}_INSTALL_NO_DEVELOPMENT)
  SET(${PROJECT_NAME}_INSTALL_NO_DEVELOPMENT 1)
ENDIF(NOT ${PROJECT_NAME}_INSTALL_NO_DEVELOPMENT)

IF(NOT ${PROJECT_NAME}_INSTALL_NO_DOCUMENTATION)
  SET(${PROJECT_NAME}_INSTALL_NO_DOCUMENTATION 1)
ENDIF(NOT ${PROJECT_NAME}_INSTALL_NO_DOCUMENTATION)

IF(APPLE)
  SET(CMAKE_CXX_FLAGS "-mlong-branch ${CMAKE_CXX_FLAGS}")
  SET(CMAKE_C_FLAGS "-mlong-branch ${CMAKE_C_FLAGS}")
  IF(NOT CPACK_SYSTEM_NAME)
    SET(CPACK_SYSTEM_NAME ${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR} CACHE STRING 
      "Installation package system")
  ENDIF(NOT CPACK_SYSTEM_NAME)

  #  MESSAGE("Checking CPACK_PACKAGE_ICON: ${CPACK_PACKAGE_ICON}")
  IF(NOT CPACK_PACKAGE_ICON)
    #  MESSAGE("CPACK_PACKAGE_ICON not set")
    MESSAGE("Setting package icon, directory: ${VolViewApplications_SSOURCE_DIR}")
    SET(CPACK_PACKAGE_ICON "${VolViewApplications_SOURCE_DIR}/VolView_Mac_Icon.icns" CACHE FILEPATH 
      "File to use as the package icon.")
    #    MESSAGE("Setting package icon: ${CPACK_PACKAGE_ICON}")
  ELSE (NOT CPACK_PACKAGE_ICON)
    #   MESSAGE("CPACK_PACKAGE_ICON set")
  ENDIF (NOT CPACK_PACKAGE_ICON)
ENDIF(APPLE)

# Testing

IF(NOT DEFINED BUILD_TESTING)
  INCLUDE(CTest)
  MARK_AS_ADVANCED(BUILD_TESTING DART_ROOT TCL_TCLSH)
ENDIF(NOT DEFINED BUILD_TESTING)
IF(BUILD_TESTING)
  ENABLE_TESTING()
ENDIF(BUILD_TESTING)

# Sub-projects
SET( Package_Names
    Kitware
)

FOREACH(package ${Package_Names})
  SET(${package}_INSTALL_BIN_DIR ${${PROJECT_NAME}_INSTALL_BIN_DIR})
  SET(${package}_INSTALL_LIB_DIR ${${PROJECT_NAME}_INSTALL_LIB_DIR})
  # Do not set the data dir, let's the sub-project set their own
  # SET(${package}_INSTALL_DATA_DIR ${${PROJECT_NAME}_INSTALL_DATA_DIR})
  SET(${package}_INSTALL_NO_DEVELOPMENT 
    ${${PROJECT_NAME}_INSTALL_NO_DEVELOPMENT})
  SET(${package}_INSTALL_NO_DOCUMENTATION 
    ${${PROJECT_NAME}_INSTALL_NO_DOCUMENTATION})
  SET(${package}_INSTALL_NO_RUNTIME 
    ${${PROJECT_NAME}_INSTALL_NO_RUNTIME})
  SUBDIRS(${package})
ENDFOREACH(package)

=== VolViewLibraries/CMakeLists.txt ===
##=========================================================================
## 
##   Copyright (c) Kitware, Inc.
##   All rights reserved.
##   See Copyright.txt or http://www.kitware.com/VolViewCopyright.htm for details.
## 
##      This software is distributed WITHOUT ANY WARRANTY; without even
##      the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##      PURPOSE.  See the above copyright notice for more information.
## 
##=========================================================================
cmake_minimum_required(VERSION 2.4)
if(COMMAND CMAKE_POLICY)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND CMAKE_POLICY)

project(VolViewLibraries)

# --------------------------------------------------------------------------
# To use this library in a larger project you will need to SUBDIR into this
# directory so that it gets built and then you will use the following variables
# in your CMakeLists files to get the proper include paths and libraries
set(VolViewLibraries_INCLUDE_PATH ""
  CACHE INTERNAL "include paths for VolViewLibraries")

set(VolViewLibraries_LIBRARIES ""
  CACHE INTERNAL "libraries for VolViewLibraries")

# You will also need to define a value for the following variables:
# VolViewLibraries_INSTALL_BIN_DIR          - binary dir (executables)
# VolViewLibraries_INSTALL_LIB_DIR          - library dir (libs)
# VolViewLibraries_INSTALL_DATA_DIR         - share dir (say, examples, data)
# VolViewLibraries_INSTALL_INCLUDE_DIR      - include dir (headers)
# VolViewLibraries_INSTALL_PACKAGE_DIR      - package/export config files
# VolViewLibraries_VTK_INSTALL_PACKAGE_DIR  - VTK package/export config files
# VolViewLibraries_ITK_INSTALL_PACKAGE_DIR  - ITK package/export config files
# VolViewLibraries_KWVolView_INSTALL_PACKAGE_DIR  - KWVolView package/export config files
# VolViewLibraries_INSTALL_NO_DEVELOPMENT   - do not install development files
# VolViewLibraries_INSTALL_NO_RUNTIME       - do not install runtime files
# VolViewLibraries_INSTALL_NO_DOCUMENTATION - do not install doc files
# --------------------------------------------------------------------------

# --------------------------------------------------------------------------
# Version

set(VolViewLibraries_MAJOR_VERSION 1)
set(VolViewLibraries_MINOR_VERSION 0)

# --------------------------------------------------------------------------
# A few important variables

set(WIN32_64BITS ${CMAKE_CL_64})

set(VolViewLibraries_USE_GDCM 1)

set(BUILD_EXAMPLES 0)

# CMake includes
include (CheckIncludeFiles)

# --------------------------------------------------------------------------
# We need various packages

macro(VolViewLibraries_REQUIRE_PACKAGE PACKAGE_NAME)
  if(NOT ${PACKAGE_NAME}_SOURCE_DIR)
    find_package(${PACKAGE_NAME} REQUIRED)
    if(${PACKAGE_NAME}_FOUND)
      include(${${PACKAGE_NAME}_USE_FILE})
    endif(${PACKAGE_NAME}_FOUND)
  endif(NOT ${PACKAGE_NAME}_SOURCE_DIR)
endmacro(VolViewLibraries_REQUIRE_PACKAGE PACKAGE_NAME)

# KWWidgets (this will bring VTK)

volviewlibraries_require_package(KWWidgets)
mark_as_advanced(CMAKE_BUILD_TYPE)

# ITK
# Not sure yet if we should include the package, since it brings so many
# include paths and dependencies. But we need to check the GDCM issue.
# Maybe this can be put in a macro.

option(VolViewLibraries_USE_ITK "Enable ITK support." 0)
if(VolViewLibraries_USE_ITK)
  volviewlibraries_require_package(ITK)
  if(NOT ITK_USE_SYSTEM_GDCM AND VolViewLibraries_USE_GDCM)
    message(FATAL_ERROR "${PROJECT_NAME} uses its own version of the GDCM library, but so does ITK. For ITK support to be enabled, please make sure ITK is using the GDCM library built by ${PROJECT_NAME}. In order to do so, please:\n  - turn VolViewLibraries_USE_ITK back to OFF,\n  - build the entire ${PROJECT_NAME} project,\n  - set ITK_USE_SYSTEM_GDCM to ON in ITK,\n  - set GDCM_DIR to ${PROJECT_BINARY_DIR}/Utilities/gdcm in ITK,\n  - build ITK,\n  - turn VolViewLibraries_USE_ITK back to ON,\n  - build ${PROJECT_NAME}.")
  endif(NOT ITK_USE_SYSTEM_GDCM AND VolViewLibraries_USE_GDCM)
endif(VolViewLibraries_USE_ITK)

# --------------------------------------------------------------------------
# Output directories

if(NOT LIBRARY_OUTPUT_PATH)
  set(LIBRARY_OUTPUT_PATH ${VolViewLibraries_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all libraries.")
endif(NOT LIBRARY_OUTPUT_PATH)

set(VolViewLibraries_LIBRARY_DIRS ${LIBRARY_OUTPUT_PATH})
set(VolViewLibraries_RUNTIME_DIRS ${LIBRARY_OUTPUT_PATH})

if(NOT EXECUTABLE_OUTPUT_PATH)
  set(EXECUTABLE_OUTPUT_PATH ${VolViewLibraries_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all executables.")
endif(NOT EXECUTABLE_OUTPUT_PATH)
set(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

# --------------------------------------------------------------------------
# Some flags

# Disable deprecation warnings for standard C functions and all the	 
# 1.276E1265 security warnings	 
if(CMAKE_COMPILER_2005)
  add_definitions(
    -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
    -D_CRT_IS_WCTYPE_NO_DEPRECATE 
    -D_CRT_MANAGED_FP_NO_DEPRECATE
    -D_CRT_NONSTDC_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
    -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
    -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
    -D_CRT_VCCLRIT_NO_DEPRECATE
    -D_SCL_SECURE_NO_DEPRECATE
    )
endif(CMAKE_COMPILER_2005)

if(APPLE)
  set(CMAKE_CXX_FLAGS "-mlong-branch ${CMAKE_CXX_FLAGS}")
  set(CMAKE_C_FLAGS "-mlong-branch ${CMAKE_C_FLAGS}")
endif(APPLE)

set(BUILD_SHARED_LIBS ${VTK_BUILD_SHARED_LIBS})
set(VolViewLibraries_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

set(VolViewLibraries_CMAKE_DIR "${VolViewLibraries_SOURCE_DIR}/CMake")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${VolViewLibraries_CMAKE_DIR}")

set(VolViewLibraries_CONFIGURATION_TYPES ${CMAKE_CONFIGURATION_TYPES})

mark_as_advanced(CMAKE_BACKWARDS_COMPATIBILITY)
if(NOT WIN32)
  mark_as_advanced(
    TCL_INCLUDE_PATH
    TCL_LIBRARY_DEBUG
    TK_INCLUDE_PATH
    TK_LIBRARY_DEBUG
    TK_WISH
    )
endif(NOT WIN32)

if(NOT WIN32 AND BUILD_SHARED_LIBS)
  option(VolViewLibraries_USE_RPATH 
    "Enable RPATH support. Leave it ON unless you really need that feature." 
    ON)
  mark_as_advanced(VolViewLibraries_USE_RPATH)
  if(VolViewLibraries_USE_RPATH)
    set(CMAKE_SKIP_RPATH OFF CACHE INTERNAL "" FORCE)
  else(VolViewLibraries_USE_RPATH)
    set(CMAKE_SKIP_RPATH ON CACHE INTERNAL "" FORCE)
  endif(VolViewLibraries_USE_RPATH)
endif(NOT WIN32 AND BUILD_SHARED_LIBS)

# --------------------------------------------------------------------------
# Testing

include(CTest)
mark_as_advanced(BUILD_TESTING DART_ROOT TCL_TCLSH)
if(BUILD_TESTING)
  enable_testing()
  find_path(VolView_DATA_ROOT VolViewDataREADME.txt 
    ${VolViewLibraries_SOURCE_DIR}/../VolViewData 
    ${VolViewLibraries_SOURCE_DIR}/../../VolViewData 
    ${VolViewLibraries_SOURCE_DIR}/../VolViewData-cvs 
    ${VolViewLibraries_SOURCE_DIR}/../../VolViewData-cvs 
    $ENV{VolViewData_ROOT}
    )
  mark_as_advanced(VolView_DATA_ROOT)
endif(BUILD_TESTING)

# --------------------------------------------------------------------------
# Install directories

if(NOT VolViewLibraries_INSTALL_BIN_DIR)
  set(VolViewLibraries_INSTALL_BIN_DIR "/bin")
endif(NOT VolViewLibraries_INSTALL_BIN_DIR)

if(NOT VolViewLibraries_INSTALL_LIB_DIR)
  set(VolViewLibraries_INSTALL_LIB_DIR "/lib/${PROJECT_NAME}")
endif(NOT VolViewLibraries_INSTALL_LIB_DIR)

if(NOT VolViewLibraries_INSTALL_DATA_DIR)
  set(VolViewLibraries_INSTALL_DATA_DIR "/share/${PROJECT_NAME}")
endif(NOT VolViewLibraries_INSTALL_DATA_DIR)

if(NOT VolViewLibraries_INSTALL_INCLUDE_DIR)
  set(VolViewLibraries_INSTALL_INCLUDE_DIR "/include/${PROJECT_NAME}")
endif(NOT VolViewLibraries_INSTALL_INCLUDE_DIR)

if(NOT VolViewLibraries_INSTALL_PACKAGE_DIR)
  set(VolViewLibraries_INSTALL_PACKAGE_DIR ${VolViewLibraries_INSTALL_LIB_DIR})
endif(NOT VolViewLibraries_INSTALL_PACKAGE_DIR)

if(NOT VolViewLibraries_VTK_INSTALL_PACKAGE_DIR)
  set(VolViewLibraries_VTK_INSTALL_PACKAGE_DIR ${VTK_INSTALL_PACKAGE_DIR})
endif(NOT VolViewLibraries_VTK_INSTALL_PACKAGE_DIR)

if(NOT VolViewLibraries_ITK_INSTALL_PACKAGE_DIR)
  set(VolViewLibraries_ITK_INSTALL_PACKAGE_DIR ${ITK_INSTALL_PACKAGE_DIR})
endif(NOT VolViewLibraries_ITK_INSTALL_PACKAGE_DIR)

if(NOT VolViewLibraries_KWVolView_INSTALL_PACKAGE_DIR)
  set(VolViewLibraries_KWVolView_INSTALL_PACKAGE_DIR "/lib/KWVolView")
endif(NOT VolViewLibraries_KWVolView_INSTALL_PACKAGE_DIR)

option(VolViewLibraries_INSTALL_DEVELOPMENT "Install VolViewLibraries development components (headers, config files, etc.)" 0)
mark_as_advanced(VolViewLibraries_INSTALL_DEVELOPMENT)
if(VolViewLibraries_INSTALL_DEVELOPMENT)
  set(VolViewLibraries_INSTALL_NO_DEVELOPMENT 0)
else(VolViewLibraries_INSTALL_DEVELOPMENT)
  set(VolViewLibraries_INSTALL_NO_DEVELOPMENT 1)
endif(VolViewLibraries_INSTALL_DEVELOPMENT)

if(NOT VolViewLibraries_INSTALL_NO_RUNTIME)
  if(VolViewLibraries_BUILD_SHARED_LIBS)
    set(VolViewLibraries_INSTALL_NO_RUNTIME 0)
  else(VolViewLibraries_BUILD_SHARED_LIBS)
    set(VolViewLibraries_INSTALL_NO_RUNTIME 1)
  endif(VolViewLibraries_BUILD_SHARED_LIBS)
endif(NOT VolViewLibraries_INSTALL_NO_RUNTIME)

if(NOT VolViewLibraries_INSTALL_NO_DOCUMENTATION)
  set(VolViewLibraries_INSTALL_NO_DOCUMENTATION 0)
endif(NOT VolViewLibraries_INSTALL_NO_DOCUMENTATION)

set(VolViewLibraries_INSTALL_NO_LIBRARIES)
if(VolViewLibraries_BUILD_SHARED_LIBS)
  if(VolViewLibraries_INSTALL_NO_RUNTIME AND 
      VolViewLibraries_INSTALL_NO_DEVELOPMENT)
    set(VolViewLibraries_INSTALL_NO_LIBRARIES 1)
  endif(VolViewLibraries_INSTALL_NO_RUNTIME AND 
    VolViewLibraries_INSTALL_NO_DEVELOPMENT)
else(VolViewLibraries_BUILD_SHARED_LIBS)
  if(VolViewLibraries_INSTALL_NO_DEVELOPMENT)
    set(VolViewLibraries_INSTALL_NO_LIBRARIES 1)
  endif(VolViewLibraries_INSTALL_NO_DEVELOPMENT)
endif(VolViewLibraries_BUILD_SHARED_LIBS)

# Propagate to all packages

foreach(package
    VTKEdge
    GDCM
    CTNLIB
    Curl
    KWCommon
    KWCommonPro
    KWWidgetsPro
    KWVolView
    )
  set(${package}_BUILD_SHARED_LIBS 
    ${VolViewLibraries_BUILD_SHARED_LIBS})
  set(${package}_INSTALL_BIN_DIR 
    ${VolViewLibraries_INSTALL_BIN_DIR})
  set(${package}_VTK_INSTALL_PACKAGE_DIR 
    ${VolViewLibraries_VTK_INSTALL_PACKAGE_DIR})
  set(${package}_ITK_INSTALL_PACKAGE_DIR 
    ${VolViewLibraries_ITK_INSTALL_PACKAGE_DIR})
  set(${package}_INSTALL_NO_DEVELOPMENT 
    ${VolViewLibraries_INSTALL_NO_DEVELOPMENT})
  set(${package}_INSTALL_NO_RUNTIME 
    ${VolViewLibraries_INSTALL_NO_RUNTIME})
  set(${package}_INSTALL_NO_DOCUMENTATION 
    ${VolViewLibraries_INSTALL_NO_DOCUMENTATION})

  # Do *not* propagate:
  # - VolViewLibraries_INSTALL_INCLUDE_DIR (way too messy)
  # - VolViewLibraries_INSTALL_LIB_DIR     (too messy)
  # - VolViewLibraries_INSTALL_PACKAGE_DIR (too messy)
  # - VolViewLibraries_INSTALL_DATA_DIR    (personal preference)
  #SET(${package}_INSTALL_PACKAGE_DIR 
  #  ${VolViewLibraries_INSTALL_PACKAGE_DIR})

endforeach(package)

# --------------------------------------------------------------------------
# Utilities: Tcl/Tk

if(WIN32)
  set(APPLICATION_BINARY_DIR) # we do not need the DLL in the build dir
  #SET(TclTk_BIN_DIR)         # (same)
  if(NOT DEFINED TclTk_LIB_DIR)
    if(BUILD_SHARED_LIBS)
      set(TclTk_LIB_DIR)
    else(BUILD_SHARED_LIBS)
      set(TclTk_LIB_DIR "${VolViewLibraries_BINARY_DIR}/lib")
    endif(BUILD_SHARED_LIBS)
    set(TclTk_INSTALL_LIB_DIR "/lib")
    set(TclTk_INSTALL_BIN_DIR ${VolViewLibraries_INSTALL_BIN_DIR})
    add_subdirectory(
      ${CMAKE_CURRENT_SOURCE_DIR}/Utilities/TclTk
      ${CMAKE_CURRENT_BINARY_DIR}/Utilities/TclTk)
  endif(NOT DEFINED TclTk_LIB_DIR)
endif(WIN32)

# --------------------------------------------------------------------------
# VTKEdge

set(VTKEdge_DIR ${VolViewLibraries_BINARY_DIR}/VTKEdge)
set(VTKEdge_BUILD_Common_KIT_DEFAULT ON)
set(VTKEdge_BUILD_Filtering_KIT_DEFAULT OFF)
set(VTKEdge_BUILD_Graphics_KIT_DEFAULT ON)

=== VolViewPlatformComplete/CMakeLists.txt ===
##=========================================================================
## 
##   Copyright (c) Kitware, Inc.
##   All rights reserved.
##   See Copyright.txt or http://www.kitware.com/VolViewCopyright.htm for details.
## 
##      This software is distributed WITHOUT ANY WARRANTY; without even
##      the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##      PURPOSE.  See the above copyright notice for more information.
## 
##=========================================================================
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

project(VolViewPlatform)

# --------------------------------------------------------------------------
# VolViewPlatform_INSTALL_BIN_DIR          - binary dir (executables)
# VolViewPlatform_INSTALL_LIB_DIR          - library dir (libs)
# VolViewPlatform_INSTALL_DATA_DIR         - share dir (say, examples, data)
# VolViewPlatform_INSTALL_INCLUDE_DIR      - include dir (headers)
# VolViewPlatform_INSTALL_PACKAGE_DIR      - package/export config files
# VolViewPlatform_INSTALL_NO_DEVELOPMENT   - do not install development files
# VolViewPlatform_INSTALL_NO_RUNTIME       - do not install runtime files
# VolViewPlatform_INSTALL_NO_DOCUMENTATION - do not install doc files
# --------------------------------------------------------------------------

# --------------------------------------------------------------------------
# Version

set(VolViewPlatform_MAJOR_VERSION 1)
set(VolViewPlatform_MINOR_VERSION 0)

# --------------------------------------------------------------------------
# Output directories

if(NOT LIBRARY_OUTPUT_PATH)
  set(LIBRARY_OUTPUT_PATH ${VolViewPlatform_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all libraries.")
endif(NOT LIBRARY_OUTPUT_PATH)

if(NOT EXECUTABLE_OUTPUT_PATH)
  set(EXECUTABLE_OUTPUT_PATH ${VolViewPlatform_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all executables.")
endif(NOT EXECUTABLE_OUTPUT_PATH)
set(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

# --------------------------------------------------------------------------
# Some flags

if(APPLE)
  set(CMAKE_CXX_FLAGS "-mlong-branch ${CMAKE_CXX_FLAGS}")
  set(CMAKE_C_FLAGS "-mlong-branch ${CMAKE_C_FLAGS}")
endif(APPLE)

option(BUILD_SHARED_LIBS "Build with shared libraries." ON)
set(VolViewPlatform_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

option(BUILD_TESTING "Build testing." OFF)
option(VTK_BUILD_TESTING "Build VTK Testing." OFF)
option(ITK_BUILD_TESTING "Build ITK Testing." OFF)
mark_as_advanced(BUILD_TESTING VTK_BUILD_TESTING ITK_BUILD_TESTING)

# Disable deprecation warnings for standard C functions and all the	 
# 1.276E1265 security warnings	 
if(CMAKE_COMPILER_2005)
  add_definitions(
    -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
    -D_CRT_IS_WCTYPE_NO_DEPRECATE 
    -D_CRT_MANAGED_FP_NO_DEPRECATE
    -D_CRT_NONSTDC_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
    -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
    -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
    -D_CRT_VCCLRIT_NO_DEPRECATE
    -D_SCL_SECURE_NO_DEPRECATE)
endif(CMAKE_COMPILER_2005)

mark_as_advanced(CMAKE_BACKWARDS_COMPATIBILITY)

# Leave skip_rpath to OFF for now. This will make the build tree
# easier to use. The install tree would be busted anyway and require
# special launchers.

set(CMAKE_SKIP_RPATH OFF CACHE INTERNAL "" FORCE)
set(VTK_USE_RPATH ON CACHE INTERNAL "" FORCE)
set(VTKEdge_PAINTBRUSH_LABEL_TYPE "VTK_UNSIGNED_CHAR" CACHE INTERNAL "" FORCE)
if(APPLE)
  set(CMAKE_INSTALL_NAME_DIR "@executable_path/../lib" CACHE INTERNAL "" FORCE)
endif(APPLE)

# --------------------------------------------------------------------------
# Find the source dirs

get_filename_component(VolViewPlatform_PARENT_DIR
  ${VolViewPlatform_SOURCE_DIR} PATH)

find_path(VTK_SOURCE_DIR
  UseVTK.cmake.in
  PATHS ${VolViewPlatform_PARENT_DIR}/VolViewExternalLibraries/VTK
  DOC "Path to VTK source dir.")

find_path(KWWidgets_SOURCE_DIR 
  vtkKWWidget.h
  PATHS ${VolViewPlatform_PARENT_DIR}/VolViewExternalLibraries/KWWidgets
  DOC "Path to KWWidgets source dir.")

find_path(ITK_SOURCE_DIR 
  UseITK.cmake.in
  PATHS ${VolViewPlatform_PARENT_DIR}/VolViewExternalLibraries/Insight
  DOC "Path to ITK source dir.")

find_path(LesionSizingKit_SOURCE_DIR 
  LesionSizingKitReadme.txt
  PATHS ${VolViewPlatform_PARENT_DIR}/VolViewExternalLibraries/LesionSizingKit
  DOC "Path to LesionSizingKit source dir.")

find_path(VolViewLibraries_SOURCE_DIR 
  KWVolView
  PATHS ${VolViewPlatform_PARENT_DIR}/VolViewLibraries
  DOC "Path to VolViewLibraries source dir.")

find_path(VolViewApplications_SOURCE_DIR 
  VolView_Mac_Icon.icns
  PATHS ${VolViewPlatform_PARENT_DIR}/VolViewApplications
  DOC "Path to VolViewApplications source dir.")

if(NOT VTK_SOURCE_DIR OR 
    NOT KWWidgets_SOURCE_DIR OR 
    NOT ITK_SOURCE_DIR OR 
    NOT VolViewLibraries_SOURCE_DIR OR 
    NOT VolViewApplications_SOURCE_DIR)
  message(FATAL_ERROR "Make sure the source directories for the following components are set:\n  - VTK,\n  - KWWidgets,\n  - ITK,\n  - VolViewLibraries,\n  - VolViewApplications.")
endif(NOT VTK_SOURCE_DIR OR 
  NOT KWWidgets_SOURCE_DIR OR 
  NOT ITK_SOURCE_DIR OR 
  NOT VolViewLibraries_SOURCE_DIR OR 
  NOT VolViewApplications_SOURCE_DIR)

# --------------------------------------------------------------------------
# Install directories

if(NOT VolViewPlatform_INSTALL_BIN_DIR)
  set(VolViewPlatform_INSTALL_BIN_DIR "/bin")
endif(NOT VolViewPlatform_INSTALL_BIN_DIR)

if(NOT VolViewPlatform_INSTALL_LIB_DIR)
  set(VolViewPlatform_INSTALL_LIB_DIR "/lib/${PROJECT_NAME}")
endif(NOT VolViewPlatform_INSTALL_LIB_DIR)

if(NOT VolViewPlatform_INSTALL_DATA_DIR)
  set(VolViewPlatform_INSTALL_DATA_DIR "/share/${PROJECT_NAME}")
endif(NOT VolViewPlatform_INSTALL_DATA_DIR)

if(NOT VolViewPlatform_INSTALL_INCLUDE_DIR)
  set(VolViewPlatform_INSTALL_INCLUDE_DIR "/include/${PROJECT_NAME}")
endif(NOT VolViewPlatform_INSTALL_INCLUDE_DIR)

if(NOT VolViewPlatform_INSTALL_PACKAGE_DIR)
  set(VolViewPlatform_INSTALL_PACKAGE_DIR ${VolViewPlatform_INSTALL_LIB_DIR})
endif(NOT VolViewPlatform_INSTALL_PACKAGE_DIR)

set(VTK_INSTALL_LIB_DIR "/lib/vtk")
if(NOT VolViewPlatform_VTK_INSTALL_PACKAGE_DIR)
  set(VolViewPlatform_VTK_INSTALL_PACKAGE_DIR 
    ${VolViewPlatform_INSTALL_PACKAGE_DIR})
endif(NOT VolViewPlatform_VTK_INSTALL_PACKAGE_DIR)

if(NOT VolViewPlatform_ITK_INSTALL_PACKAGE_DIR)
  set(VolViewPlatform_ITK_INSTALL_PACKAGE_DIR 
    ${VolViewPlatform_INSTALL_PACKAGE_DIR})
endif(NOT VolViewPlatform_ITK_INSTALL_PACKAGE_DIR)

set(VolViewPlatform_INSTALL_NO_DEVELOPMENT 1)

if(NOT VolViewPlatform_INSTALL_NO_RUNTIME)
  if(VolViewPlatform_BUILD_SHARED_LIBS)
    set(VolViewPlatform_INSTALL_NO_RUNTIME 0)
  else(VolViewPlatform_BUILD_SHARED_LIBS)
    set(VolViewPlatform_INSTALL_NO_RUNTIME 1)
  endif(VolViewPlatform_BUILD_SHARED_LIBS)
endif(NOT VolViewPlatform_INSTALL_NO_RUNTIME)

if(NOT VolViewPlatform_INSTALL_NO_DOCUMENTATION)
  set(VolViewPlatform_INSTALL_NO_DOCUMENTATION 1)
endif(NOT VolViewPlatform_INSTALL_NO_DOCUMENTATION)

set(VolViewPlatform_INSTALL_NO_LIBRARIES)
if(VolViewPlatform_BUILD_SHARED_LIBS)
  if(VolViewPlatform_INSTALL_NO_RUNTIME AND 
      VolViewPlatform_INSTALL_NO_DEVELOPMENT)
    set(VolViewPlatform_INSTALL_NO_LIBRARIES 1)
  endif(VolViewPlatform_INSTALL_NO_RUNTIME AND 
    VolViewPlatform_INSTALL_NO_DEVELOPMENT)
else(VolViewPlatform_BUILD_SHARED_LIBS)
  if(VolViewPlatform_INSTALL_NO_DEVELOPMENT)
    set(VolViewPlatform_INSTALL_NO_LIBRARIES 1)
  endif(VolViewPlatform_INSTALL_NO_DEVELOPMENT)
endif(VolViewPlatform_BUILD_SHARED_LIBS)

# Propagate to all components

foreach(component
    VTK
    KWWidgets
    GDCM
    ITK
    VolViewLibraries
    VolViewApplications
    )
  set(${component}_BUILD_SHARED_LIBS 
    ${VolViewPlatform_BUILD_SHARED_LIBS})
  set(${component}_INSTALL_BIN_DIR 
    ${VolViewPlatform_INSTALL_BIN_DIR})
  set(${component}_VTK_INSTALL_PACKAGE_DIR 
    ${VolViewPlatform_VTK_INSTALL_PACKAGE_DIR})
  set(${component}_ITK_INSTALL_PACKAGE_DIR 
    ${VolViewPlatform_ITK_INSTALL_PACKAGE_DIR})

  set(${component}_INSTALL_NO_DEVELOPMENT 
    ${VolViewPlatform_INSTALL_NO_DEVELOPMENT})
  set(${component}_INSTALL_NO_RUNTIME 
    ${VolViewPlatform_INSTALL_NO_RUNTIME})
  set(${component}_INSTALL_NO_DOCUMENTATION 
    ${VolViewPlatform_INSTALL_NO_DOCUMENTATION})

  # Do *not* propagate:
  # - VolViewPlatform_INSTALL_INCLUDE_DIR (way too messy)
  # - VolViewPlatform_INSTALL_LIB_DIR     (too messy)
  # - VolViewPlatform_INSTALL_PACKAGE_DIR (too messy)
  # - VolViewPlatform_INSTALL_DATA_DIR    (personal preference)
  #SET(${component}_INSTALL_PACKAGE_DIR 
  #  ${VolViewPlatform_INSTALL_PACKAGE_DIR})

endforeach(component)

# --------------------------------------------------------------------------
# VTK

set(VTK_WRAP_TCL ON CACHE INTERNAL "" FORCE)

if(VolViewPlatform_BUILD_SHARED_LIBS)
  set(VTK_TCL_TK_STATIC OFF CACHE INTERNAL "" FORCE)
else(VolViewPlatform_BUILD_SHARED_LIBS)
  set(VTK_TCL_TK_STATIC ON CACHE INTERNAL "" FORCE)
endif(VolViewPlatform_BUILD_SHARED_LIBS)

# We need Tcl/Tk now

set(VTK_TCL_TK_MACROS_MODULE 
  "${VTK_SOURCE_DIR}/CMake/vtkTclTkMacros.cmake")
set(TclTk_BIN_DIR "${LIBRARY_OUTPUT_PATH}")
set(TclTk_LIB_DIR "${PROJECT_BINARY_DIR}/lib")
set(TclTk_INSTALL_LIB_DIR "/lib")
set(TclTk_INSTALL_BIN_DIR ${VolViewPlatform_INSTALL_BIN_DIR})
add_subdirectory(
  ${VolViewLibraries_SOURCE_DIR}/Utilities/TclTk
  ${VolViewPlatform_BINARY_DIR}/VolViewLibraries/Utilities/TclTk)
set(OLD_BUILD_TESTING ${BUILD_TESTING})
set(BUILD_TESTING ${VTK_BUILD_TESTING})

# Add VTK

set(METAIO_USE_OpenJPEG_DEFAULT ON)
set(VTK_DIR ${VolViewPlatform_BINARY_DIR}/VTK)
add_subdirectory(${VTK_SOURCE_DIR} ${VTK_DIR})

set(BUILD_TESTING ${OLD_BUILD_TESTING})

mark_as_advanced(
  BUILD_EXAMPLES
  VTK_DATA_ROOT
  VTK_USE_CG_SHADERS
  VTK_USE_FFMPEG_ENCODER
  VTK_USE_GLSL_SHADERS
  VTK_USE_PARALLEL
  VTK_USE_RENDERING
  VTK_USE_RPATH
  VTK_WRAP_JAVA
  VTK_WRAP_PYTHON
  )

# --------------------------------------------------------------------------
# Build OpenJPEG.
SET( OpenJPEG_INCLUDE_DIR ${VTK_SOURCE_DIR}/Utilities/OpenJPEG/libopenjpeg 
                          ${VTK_BINARY_DIR}/Utilities/OpenJPEG/libopenjpeg CACHE INTERNAL "" FORCE )
SET( OpenJPEG_LIBRARY vtkopenjpeg CACHE INTERNAL "" FORCE )
SET( OpenJPEG_JP3DVM_INCLUDE_DIR ${VTK_SOURCE_DIR}/Utilities/OpenJPEG/jp3d/libjp3dvm 
                                 ${VTK_BINARY_DIR}/Utilities/OpenJPEG/jp3d/libjp3dvm
                                 CACHE INTERNAL "" FORCE )
SET( OpenJPEG_JP3DVM_LIBRARY vtkopenjp3dvm  CACHE INTERNAL "" FORCE)
SET( OpenJPEG_FOUND_DEFAULT TRUE  CACHE INTERNAL "" FORCE)
SET( OpenJPEG_JP3DVM_FOUND_DEFAULT TRUE  CACHE INTERNAL "" FORCE)


# --------------------------------------------------------------------------
# VolViewLibraries: Utilities: GDCM

set(GDCM_BUILD_EXAMPLES_DEFAULT 0)
set(GDCM_BUILD_TESTING_DEFAULT 0)
set(GDCM_INSTALL_NO_DICTIONARY 1)
set(GDCM_VTK_DEFAULT ON)
set(GDCM_PUB_DICT_PATH "")
set(OPENJPEG_BUILD_SHARED_LIBS ${GDCM_BUILD_SHARED_LIBS})
mark_as_advanced(
  GDCM_BUILD_EXAMPLES
  GDCM_BUILD_SHARED_LIBS
  GDCM_DATA_ROOT
  GDCM_DOCUMENTATION
  GDCM_FORCE_BIGENDIAN_EMULATION
  GDCM_INSTALLER
  GDCM_PUB_DICT_PATH
  GDCM_VTK
  GDCM_WRAP_PYTHON
  )

# GDCM contains an older version of OpenJPEG. We will use the system
# version of OpenJPEG that provides support for JP3D (JPEG2000 Part 10
# Volumetric Compression) among other things.
SET( GDCM_USE_SYSTEM_OpenJPEG ON CACHE INTERNAL "" FORCE )

set(GDCM_DIR ${VolViewPlatform_BINARY_DIR}/VolViewLibraries/Utilities/gdcm)
add_subdirectory(${VolViewLibraries_SOURCE_DIR}/Utilities/gdcm ${GDCM_DIR})

# --------------------------------------------------------------------------
# VolViewLibraries: Utilities: gettext

if(WIN32)
  set(GETTEXT_INCLUDE_DIR 
    "${VolViewLibraries_SOURCE_DIR}/Utilities/gettext/include" CACHE PATH "")

=== VolViewApplications/Kitware/CMakeLists.txt ===
##=========================================================================
## 
##   Copyright (c) Kitware, Inc.
##   All rights reserved.
##   See Copyright.txt or http://www.kitware.com/VolViewCopyright.htm for details.
## 
##      This software is distributed WITHOUT ANY WARRANTY; without even
##      the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##      PURPOSE.  See the above copyright notice for more information.
## 
##=========================================================================
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(Kitware)

# Output paths

IF(NOT LIBRARY_OUTPUT_PATH)
  SET(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
    
IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)

# Install paths

IF(NOT ${PROJECT_NAME}_INSTALL_BIN_DIR)
  SET(${PROJECT_NAME}_INSTALL_BIN_DIR "/bin")
ENDIF(NOT ${PROJECT_NAME}_INSTALL_BIN_DIR)

IF(NOT ${PROJECT_NAME}_INSTALL_LIB_DIR)
  SET(${PROJECT_NAME}_INSTALL_LIB_DIR "/lib/${PROJECT_NAME}")
ENDIF(NOT ${PROJECT_NAME}_INSTALL_LIB_DIR)

IF(NOT ${PROJECT_NAME}_INSTALL_DATA_DIR)
  SET(${PROJECT_NAME}_INSTALL_DATA_DIR "/share/${PROJECT_NAME}")
ENDIF(NOT ${PROJECT_NAME}_INSTALL_DATA_DIR)

IF(NOT ${PROJECT_NAME}_INSTALL_INCLUDE_DIR)
  SET(${PROJECT_NAME}_INSTALL_INCLUDE_DIR "/include/${PROJECT_NAME}")
ENDIF(NOT ${PROJECT_NAME}_INSTALL_INCLUDE_DIR)

IF(NOT ${PROJECT_NAME}_INSTALL_PACKAGE_DIR)
  SET(${PROJECT_NAME}_INSTALL_PACKAGE_DIR ${${PROJECT_NAME}_INSTALL_LIB_DIR})
ENDIF(NOT ${PROJECT_NAME}_INSTALL_PACKAGE_DIR)

IF(NOT ${PROJECT_NAME}_INSTALL_NO_DEVELOPMENT)
  SET(${PROJECT_NAME}_INSTALL_NO_DEVELOPMENT 1)
ENDIF(NOT ${PROJECT_NAME}_INSTALL_NO_DEVELOPMENT)

IF(NOT ${PROJECT_NAME}_INSTALL_NO_DOCUMENTATION)
  SET(${PROJECT_NAME}_INSTALL_NO_DOCUMENTATION 1)
ENDIF(NOT ${PROJECT_NAME}_INSTALL_NO_DOCUMENTATION)

# Testing

IF(NOT DEFINED BUILD_TESTING)
  INCLUDE(CTest)
  MARK_AS_ADVANCED(BUILD_TESTING DART_ROOT TCL_TCLSH)
ENDIF(NOT DEFINED BUILD_TESTING)
IF(BUILD_TESTING)
  ENABLE_TESTING()
ENDIF(BUILD_TESTING)

# Sub-projects

OPTION(BUILD_${PROJECT_NAME}_APPLICATIONS
  "Build ${PROJECT_NAME} applications and support libraries." ON)
IF(BUILD_${PROJECT_NAME}_APPLICATIONS)
  FOREACH(package
      VolView
      )
    SET(${package}_INSTALL_BIN_DIR ${${PROJECT_NAME}_INSTALL_BIN_DIR})
    SET(${package}_INSTALL_LIB_DIR ${${PROJECT_NAME}_INSTALL_LIB_DIR})
    # Do not set the data dir, let's the sub-project set their own
    # SET(${package}_INSTALL_DATA_DIR ${${PROJECT_NAME}_INSTALL_DATA_DIR})
    SET(${package}_INSTALL_NO_DEVELOPMENT 
      ${${PROJECT_NAME}_INSTALL_NO_DEVELOPMENT})
    SET(${package}_INSTALL_NO_DOCUMENTATION 
      ${${PROJECT_NAME}_INSTALL_NO_DOCUMENTATION})
    SET(${package}_INSTALL_NO_RUNTIME 
      ${${PROJECT_NAME}_INSTALL_NO_RUNTIME})
    SUBDIRS(${package})
  ENDFOREACH(package)
ENDIF(BUILD_${PROJECT_NAME}_APPLICATIONS)

=== VolViewExternalLibraries/LesionSizingKit/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(LesionSizingKitGlobal)

ADD_SUBDIRECTORY(Sandbox)

=== VolViewLibraries/KWCommon/CMakeLists.txt ===
##=========================================================================
## 
##   Copyright (c) Kitware, Inc.
##   All rights reserved.
##   See Copyright.txt or http://www.kitware.com/VolViewCopyright.htm for details.
## 
##      This software is distributed WITHOUT ANY WARRANTY; without even
##      the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##      PURPOSE.  See the above copyright notice for more information.
## 
##=========================================================================
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(KWCommon)

# --------------------------------------------------------------------------
# To use this library in a larger project you will need to SUBDIR into this
# directory so that it gets built and then you will use the following variables
# in your CMakeLists files to get the proper include paths and libraries

SET(KWCommon_INCLUDE_PATH 
  "${CMAKE_CURRENT_SOURCE_DIR}"
  CACHE INTERNAL "include paths for KWCommon"
  )

SET(KWCommon_LIBRARIES KWCommon CACHE INTERNAL "libraries for KWCommon")

# You will also need to define a value for the following variables:
# KWCommon_INSTALL_BIN_DIR          - binary dir (executables)
# KWCommon_INSTALL_LIB_DIR          - library dir (libs)
# KWCommon_INSTALL_DATA_DIR         - share dir (say, examples, data, etc)
# KWCommon_INSTALL_INCLUDE_DIR      - include dir (headers)
# KWCommon_INSTALL_PACKAGE_DIR      - package/export configuration files
# KWCommon_VTK_INSTALL_PACKAGE_DIR  - VTK package/export configuration files
# KWCommon_INSTALL_NO_DEVELOPMENT   - do not install development files
# KWCommon_INSTALL_NO_RUNTIME       - do not install runtime files
# KWCommon_INSTALL_NO_DOCUMENTATION - do not install documentation files
# --------------------------------------------------------------------------

# --------------------------------------------------------------------------
# Version

SET(KWCommon_MAJOR_VERSION 1)
SET(KWCommon_MINOR_VERSION 0)

# --------------------------------------------------------------------------
# We need VTK

IF(NOT VTK_SOURCE_DIR)
  FIND_PACKAGE(VTK REQUIRED)
  INCLUDE(${VTK_USE_FILE})
ENDIF(NOT VTK_SOURCE_DIR)

# --------------------------------------------------------------------------
# EXPORT() will be in cmake 2.6, add an empty macro so older cmake versions stil work
IF(NOT COMMAND EXPORT)
  MACRO(EXPORT)
  ENDMACRO(EXPORT)
ENDIF(NOT COMMAND EXPORT)

# --------------------------------------------------------------------------
# Output directories

IF(NOT LIBRARY_OUTPUT_PATH)
  SET(LIBRARY_OUTPUT_PATH ${KWCommon_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
SET(KWCommon_LIBRARY_DIRS ${LIBRARY_OUTPUT_PATH})
SET(KWCommon_RUNTIME_DIRS ${LIBRARY_OUTPUT_PATH})

IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET(EXECUTABLE_OUTPUT_PATH ${KWCommon_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)

# --------------------------------------------------------------------------
# Some flags

INCLUDE_REGULAR_EXPRESSION("^(vtk|kw|icons).*$")
SET(CMAKE_C_FLAGS "${CMAKE_ANSI_CFLAGS} ${CMAKE_C_FLAGS}")
IF(CMAKE_COMPILER_2005)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
ENDIF(CMAKE_COMPILER_2005)

MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)

SET(BUILD_SHARED_LIBS ${VTK_BUILD_SHARED_LIBS})
SET(KWCommon_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

SET(KWCommon_CMAKE_DIR "${KWCommon_SOURCE_DIR}/CMake")
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${KWCommon_CMAKE_DIR}")

SET(KWCommon_CONFIGURATION_TYPES ${CMAKE_CONFIGURATION_TYPES})

# --------------------------------------------------------------------------
# Install directories

IF(NOT KWCommon_INSTALL_BIN_DIR)
  SET(KWCommon_INSTALL_BIN_DIR "/bin")
ENDIF(NOT KWCommon_INSTALL_BIN_DIR)

IF(NOT KWCommon_INSTALL_LIB_DIR)
  SET(KWCommon_INSTALL_LIB_DIR "/lib/${PROJECT_NAME}")
ENDIF(NOT KWCommon_INSTALL_LIB_DIR)

IF(NOT KWCommon_INSTALL_DATA_DIR)
  SET(KWCommon_INSTALL_DATA_DIR "/share/${PROJECT_NAME}")
ENDIF(NOT KWCommon_INSTALL_DATA_DIR)

IF(NOT KWCommon_INSTALL_INCLUDE_DIR)
  SET(KWCommon_INSTALL_INCLUDE_DIR "/include/${PROJECT_NAME}")
ENDIF(NOT KWCommon_INSTALL_INCLUDE_DIR)

IF(NOT KWCommon_INSTALL_PACKAGE_DIR)
  SET(KWCommon_INSTALL_PACKAGE_DIR ${KWCommon_INSTALL_LIB_DIR}
    CACHE INTERNAL "")
ENDIF(NOT KWCommon_INSTALL_PACKAGE_DIR)

IF(NOT KWCommon_VTK_INSTALL_PACKAGE_DIR)
  SET(KWCommon_VTK_INSTALL_PACKAGE_DIR ${VTK_INSTALL_PACKAGE_DIR})
ENDIF(NOT KWCommon_VTK_INSTALL_PACKAGE_DIR)

IF(NOT KWCommon_INSTALL_NO_DEVELOPMENT)
  SET(KWCommon_INSTALL_NO_DEVELOPMENT 0)
ENDIF(NOT KWCommon_INSTALL_NO_DEVELOPMENT)

IF(NOT KWCommon_INSTALL_NO_RUNTIME)
  SET(KWCommon_INSTALL_NO_RUNTIME 0)
ENDIF(NOT KWCommon_INSTALL_NO_RUNTIME)

IF(NOT KWCommon_INSTALL_NO_DOCUMENTATION)
  SET(KWCommon_INSTALL_NO_DOCUMENTATION 0)
ENDIF(NOT KWCommon_INSTALL_NO_DOCUMENTATION)

SET(KWCommon_INSTALL_NO_LIBRARIES)
IF(KWCommon_BUILD_SHARED_LIBS)
  IF(KWCommon_INSTALL_NO_RUNTIME AND KWCommon_INSTALL_NO_DEVELOPMENT)
    SET(KWCommon_INSTALL_NO_LIBRARIES 1)
  ENDIF(KWCommon_INSTALL_NO_RUNTIME AND KWCommon_INSTALL_NO_DEVELOPMENT)
ELSE(KWCommon_BUILD_SHARED_LIBS)
  IF(KWCommon_INSTALL_NO_DEVELOPMENT)
    SET(KWCommon_INSTALL_NO_LIBRARIES 1)
  ENDIF(KWCommon_INSTALL_NO_DEVELOPMENT)
ENDIF(KWCommon_BUILD_SHARED_LIBS)

# --------------------------------------------------------------------------
# Sources

SET(KWCommon_SRCS
  vtkContainer.cxx
  vtkKWProcessStatistics.cxx
  vtkKWRemoteExecute.cxx
  vtkQueue.cxx
  )

# --------------------------------------------------------------------------
# Include dirs

IF(VTK_ZLIB_INCLUDE_DIRS)
  INCLUDE_DIRECTORIES(${VTK_ZLIB_INCLUDE_DIRS})
ENDIF(VTK_ZLIB_INCLUDE_DIRS)

INCLUDE_DIRECTORIES(
  ${KWCommon_BINARY_DIR}
  ${KWCommon_SOURCE_DIR}
  )

# --------------------------------------------------------------------------
# Build the library

ADD_LIBRARY(KWCommon ${KWCommon_SRCS})

TARGET_LINK_LIBRARIES(KWCommon
  vtkCommon
  vtksys
  )

IF(NOT KWCommon_INSTALL_NO_LIBRARIES)
  IF(PV_INSTALL_HAS_CMAKE_24)
    INSTALL(TARGETS ${KWCommon_LIBRARIES}
      RUNTIME DESTINATION ${PV_INSTALL_BIN_DIR_CM24} COMPONENT Runtime
      LIBRARY DESTINATION ${PV_INSTALL_LIB_DIR_CM24} COMPONENT Runtime
      ARCHIVE DESTINATION ${PV_INSTALL_LIB_DIR_CM24} COMPONENT Development)
  ELSE(PV_INSTALL_HAS_CMAKE_24)
    INSTALL_TARGETS(${KWCommon_INSTALL_LIB_DIR} 
      RUNTIME_DIRECTORY ${KWCommon_INSTALL_BIN_DIR}
      ${KWCommon_LIBRARIES})
  ENDIF(PV_INSTALL_HAS_CMAKE_24)
ENDIF(NOT KWCommon_INSTALL_NO_LIBRARIES)

# --------------------------------------------------------------------------
# Install the headers

FILE(GLOB templated_files "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")

IF(NOT KWCommon_INSTALL_NO_DEVELOPMENT)
  INSTALL_FILES(${KWCommon_INSTALL_INCLUDE_DIR} .h 
    ${KWCommon_SRCS} 
    ${templated_files})
  INSTALL_FILES(${KWCommon_INSTALL_INCLUDE_DIR} .txx ${templated_files})
ENDIF(NOT KWCommon_INSTALL_NO_DEVELOPMENT)

# --------------------------------------------------------------------------
# Testing

INCLUDE(Dart)
MARK_AS_ADVANCED(BUILD_TESTING DART_ROOT TCL_TCLSH)

SET(default_val 1)
IF(DEFINED KWCommon_BUILD_TESTING_DEFAULT)
  SET(default_val ${KWCommon_BUILD_TESTING_DEFAULT})
ENDIF(DEFINED KWCommon_BUILD_TESTING_DEFAULT)
OPTION(KWCommon_BUILD_TESTING 
  "Enable testing in KWCommon (if BUILD_TESTING is ON as well)." 
  ${default_val})
MARK_AS_ADVANCED(KWCommon_BUILD_TESTING)
IF(BUILD_TESTING AND KWCommon_BUILD_TESTING)
  #SET(BUILDNAME "${PROJECT_NAME}-${BUILDNAME}")
  ENABLE_TESTING()
  SUBDIRS(Testing)
ENDIF(BUILD_TESTING AND KWCommon_BUILD_TESTING)

# --------------------------------------------------------------------------
# Configure the export configuration

SUBDIRS(CMake/ExportConfiguration)

# --------------------------------------------------------------------------
# ProcessXML (is it still being used ?)

SET(KWCommon_EXE_SUFFIX)
SET(KWCommon_EXE_INSTALL ${KWCommon_INSTALL_BIN_DIR})
SET(Temp_Using_Shared_Forwarding OFF)
IF(KWCOMMON_BUILD_PROCESSXML)
  # For shared libraries on non-windows systems use the KWSys shared-forward
  # implementation to make sure shared libraries are found.
  IF(BUILD_SHARED_LIBS AND CMAKE_SKIP_RPATH)
    IF(NOT WIN32)
      SET(KWCommon_FORWARD_DIR_BUILD ${EXECUTABLE_OUTPUT_PATH})
      SET(KWCommon_FORWARD_BIN_TO_LIB "..${KWCommon_INSTALL_LIB_DIR}")
      SET(KWCommon_EXE_SUFFIX -real)
      SET(KWCommon_FORWARD_EXE "kwProcessXML${KWCommon_EXE_SUFFIX}")
      SET(KWCommon_EXE_INSTALL ${KWCommon_INSTALL_LIB_DIR})
      CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/kw-forward.c.in
                     ${CMAKE_CURRENT_BINARY_DIR}/ProcessXML-forward.c
                     @ONLY IMMEDIATE)
      ADD_EXECUTABLE(kwProcessXML
                     ${CMAKE_CURRENT_BINARY_DIR}/ProcessXML-forward.c)
      SET(Temp_Using_Shared_Forwarding ON)
      EXPORT(TARGETS kwProcessXML FILE ${EXPORT_EXECUTABLES_FILE} NAMESPACE "${EXPORT_EXECUTABLES_NAMESPACE}" APPEND)
      IF(KWCOMMON_HOST_TOOLS_TARGET)
        ADD_DEPENDENCIES(${KWCOMMON_HOST_TOOLS_TARGET} kwProcessXML)
      ENDIF(KWCOMMON_HOST_TOOLS_TARGET)
      IF(NOT KWCommon_INSTALL_NO_DEVELOPMENT)
        INSTALL(TARGETS kwProcessXML 
          DESTINATION ${PV_INSTALL_BIN_DIR}
          COMPONENT Development)
      ENDIF(NOT KWCommon_INSTALL_NO_DEVELOPMENT)
    ENDIF(NOT WIN32)
  ENDIF(BUILD_SHARED_LIBS AND CMAKE_SKIP_RPATH)

  ADD_EXECUTABLE(kwProcessXML${KWCommon_EXE_SUFFIX} ProcessXML.cxx)
  TARGET_LINK_LIBRARIES(kwProcessXML${KWCommon_EXE_SUFFIX} vtkCommon vtksys)
  EXPORT(TARGETS kwProcessXML${KWCommon_EXE_SUFFIX} FILE ${EXPORT_EXECUTABLES_FILE} NAMESPACE "${EXPORT_EXECUTABLES_NAMESPACE}" APPEND)
  IF(KWCOMMON_HOST_TOOLS_TARGET)
    ADD_DEPENDENCIES(${KWCOMMON_HOST_TOOLS_TARGET} kwProcessXML${KWCommon_EXE_SUFFIX})
  ENDIF(KWCOMMON_HOST_TOOLS_TARGET)
  IF(NOT KWCommon_INSTALL_NO_DEVELOPMENT)
    SET(kwProcessXML_real_INSTALL_DIR ${PV_INSTALL_BIN_DIR})
    IF(Temp_Using_Shared_Forwarding)
      SET(kwProcessXML_real_INSTALL_DIR ${PV_INSTALL_LIB_DIR})
    ENDIF(Temp_Using_Shared_Forwarding)
    INSTALL(TARGETS kwProcessXML${KWCommon_EXE_SUFFIX} 
      DESTINATION ${kwProcessXML_real_INSTALL_DIR}
      COMPONENT Development)
  ENDIF(NOT KWCommon_INSTALL_NO_DEVELOPMENT)
  IF(KWCommon_EXE_SUFFIX)
    ADD_DEPENDENCIES(kwProcessXML kwProcessXML${KWCommon_EXE_SUFFIX})
  ENDIF(KWCommon_EXE_SUFFIX)
ENDIF(KWCOMMON_BUILD_PROCESSXML)

=== VolViewLibraries/KWCommonPro/CMakeLists.txt ===
##=========================================================================
## 
##   Copyright (c) Kitware, Inc.
##   All rights reserved.
##   See Copyright.txt or http://www.kitware.com/VolViewCopyright.htm for details.
## 
##      This software is distributed WITHOUT ANY WARRANTY; without even
##      the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##      PURPOSE.  See the above copyright notice for more information.
## 
##=========================================================================
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(KWCommonPro)

# --------------------------------------------------------------------------
# To use this library in a larger project you will need to SUBDIR into this
# directory so that it gets built and then you will use the following variables
# in your CMakeLists files to get the proper include paths and libraries

SET(KWCommonPro_INCLUDE_PATH 
  "${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_BINARY_DIR}"
  CACHE INTERNAL "include paths for KWCommonPro"
  )

SET(KWCommonPro_LIBRARIES KWCommonPro 
  CACHE INTERNAL "libraries for KWCommonPro")

# You will also need to define a value for the following variables:
# KWCommonPro_INSTALL_BIN_DIR            - binary dir (executables)
# KWCommonPro_INSTALL_LIB_DIR            - library dir (libs)
# KWCommonPro_INSTALL_DATA_DIR           - share dir (say, examples, data, etc)
# KWCommonPro_INSTALL_INCLUDE_DIR        - include dir (headers)
# KWCommonPro_INSTALL_PACKAGE_DIR        - package/export configuration files
# KWCommonPro_KWCommon_INSTALL_PACKAGE_DIR - KWCommon package/export config
# KWCommonPro_CTNLIB_INSTALL_PACKAGE_DIR - CTNLIB package/export config files
# KWCommonPro_GDCM_INSTALL_PACKAGE_DIR   - GDCM package/export config files
# KWCommonPro_INSTALL_NO_DEVELOPMENT     - do not install development files
# KWCommonPro_INSTALL_NO_RUNTIME         - do not install runtime files
# KWCommonPro_INSTALL_NO_DOCUMENTATION   - do not install documentation files
# --------------------------------------------------------------------------

# --------------------------------------------------------------------------
# Version

SET(KWCommonPro_MAJOR_VERSION 1)
SET(KWCommonPro_MINOR_VERSION 0)

# --------------------------------------------------------------------------
# We need various packages

MACRO(KWCommonPro_REQUIRE_PACKAGE PACKAGE_NAME)
  IF(NOT ${PACKAGE_NAME}_SOURCE_DIR)
    FIND_PACKAGE(${PACKAGE_NAME} REQUIRED)
    IF(${PACKAGE_NAME}_FOUND)
      INCLUDE(${${PACKAGE_NAME}_USE_FILE})
    ENDIF(${PACKAGE_NAME}_FOUND)
  ENDIF(NOT ${PACKAGE_NAME}_SOURCE_DIR)
ENDMACRO(KWCommonPro_REQUIRE_PACKAGE PACKAGE_NAME)

# KWCommon (which brings VTK automatically)
# Important: if the dependencies to KWCommon is removed, replace KWCommon with
# VTK in this entire file, and make sure to update CMake/ExportConfiguration
# the same way as well (especially KWCommonPro_KWCommon_INSTALL_PACKAGE_DIR
# which becomes KWCommonPro_VTK_INSTALL_PACKAGE_DIR, and 
# KWCommonPro_KWCommon_DIR which becomes KWCommonPro_VTK_DIR).
# Right now the only dependency to KWCommon is the use of a vtkAbstractMap in
# vtkDICOMCollector => should be replaced with STL!

KWCommonPro_REQUIRE_PACKAGE(KWCommon)

# CTNLIB

SET(default_val 1)
IF(DEFINED KWCommonPro_USE_CTNLIB_DEFAULT)
  SET(default_val ${KWCommonPro_USE_CTNLIB_DEFAULT})
ENDIF(DEFINED KWCommonPro_USE_CTNLIB_DEFAULT)
OPTION(KWCommonPro_USE_CTNLIB
  "Build KWCommonPro using CTNLIB DICOM support." ${default_val})
MARK_AS_ADVANCED(KWCommonPro_USE_CTNLIB)
IF(KWCommonPro_USE_CTNLIB)
  KWCommonPro_REQUIRE_PACKAGE(CTNLIB)
ENDIF(KWCommonPro_USE_CTNLIB)

# GDCM

SET(default_val 1)
IF(DEFINED KWCommonPro_USE_GDCM_DEFAULT)
  SET(default_val ${KWCommonPro_USE_GDCM_DEFAULT})
ENDIF(DEFINED KWCommonPro_USE_GDCM_DEFAULT)
OPTION(KWCommonPro_USE_GDCM 
  "Build KWCommonPro using GDCM DICOM support." ${default_val})
MARK_AS_ADVANCED(KWCommonPro_USE_GDCM)
IF(KWCommonPro_USE_GDCM)
  KWCommonPro_REQUIRE_PACKAGE(GDCM)
ENDIF(KWCommonPro_USE_GDCM)

# --------------------------------------------------------------------------
# Output directories

IF(NOT LIBRARY_OUTPUT_PATH)
  SET(LIBRARY_OUTPUT_PATH ${KWCommonPro_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
SET(KWCommonPro_LIBRARY_DIRS ${LIBRARY_OUTPUT_PATH})
SET(KWCommonPro_RUNTIME_DIRS ${LIBRARY_OUTPUT_PATH})

IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET(EXECUTABLE_OUTPUT_PATH ${KWCommonPro_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)

# --------------------------------------------------------------------------
# Some flags

INCLUDE_REGULAR_EXPRESSION("^(vtk|kw|icons).*$")
SET(CMAKE_C_FLAGS "${CMAKE_ANSI_CFLAGS} ${CMAKE_C_FLAGS}")
IF(CMAKE_COMPILER_2005)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
ENDIF(CMAKE_COMPILER_2005)

SET(BUILD_SHARED_LIBS ${VTK_BUILD_SHARED_LIBS})
SET(KWCommonPro_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

SET(KWCommonPro_CMAKE_DIR "${KWCommonPro_SOURCE_DIR}/CMake")
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${KWCommonPro_CMAKE_DIR}")

SET(KWCommonPro_CONFIGURATION_TYPES ${CMAKE_CONFIGURATION_TYPES})

MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)

# --------------------------------------------------------------------------
# Install directories

IF(NOT KWCommonPro_INSTALL_BIN_DIR)
  SET(KWCommonPro_INSTALL_BIN_DIR "/bin")
ENDIF(NOT KWCommonPro_INSTALL_BIN_DIR)

IF(NOT KWCommonPro_INSTALL_LIB_DIR)
  SET(KWCommonPro_INSTALL_LIB_DIR "/lib/${PROJECT_NAME}")
ENDIF(NOT KWCommonPro_INSTALL_LIB_DIR)

IF(NOT KWCommonPro_INSTALL_DATA_DIR)
  SET(KWCommonPro_INSTALL_DATA_DIR "/share/${PROJECT_NAME}")
ENDIF(NOT KWCommonPro_INSTALL_DATA_DIR)

IF(NOT KWCommonPro_INSTALL_INCLUDE_DIR)
  SET(KWCommonPro_INSTALL_INCLUDE_DIR "/include/${PROJECT_NAME}")
ENDIF(NOT KWCommonPro_INSTALL_INCLUDE_DIR)

IF(NOT KWCommonPro_INSTALL_PACKAGE_DIR)
  SET(KWCommonPro_INSTALL_PACKAGE_DIR ${KWCommonPro_INSTALL_LIB_DIR}
    CACHE INTERNAL "")
ENDIF(NOT KWCommonPro_INSTALL_PACKAGE_DIR)

IF(NOT KWCommonPro_KWCommon_INSTALL_PACKAGE_DIR)
  SET(KWCommonPro_KWCommon_INSTALL_PACKAGE_DIR ${KWCommon_INSTALL_PACKAGE_DIR})
ENDIF(NOT KWCommonPro_KWCommon_INSTALL_PACKAGE_DIR)

IF(NOT KWCommonPro_CTNLIB_INSTALL_PACKAGE_DIR)
  SET(KWCommonPro_CTNLIB_INSTALL_PACKAGE_DIR ${CTNLIB_INSTALL_PACKAGE_DIR})
ENDIF(NOT KWCommonPro_CTNLIB_INSTALL_PACKAGE_DIR)

IF(NOT KWCommonPro_GDCM_INSTALL_PACKAGE_DIR)
  SET(KWCommonPro_GDCM_INSTALL_PACKAGE_DIR ${GDCM_INSTALL_PACKAGE_DIR})
ENDIF(NOT KWCommonPro_GDCM_INSTALL_PACKAGE_DIR)

IF(NOT KWCommonPro_INSTALL_NO_DEVELOPMENT)
  SET(KWCommonPro_INSTALL_NO_DEVELOPMENT 0)
ENDIF(NOT KWCommonPro_INSTALL_NO_DEVELOPMENT)

IF(NOT KWCommonPro_INSTALL_NO_RUNTIME)
  SET(KWCommonPro_INSTALL_NO_RUNTIME 0)
ENDIF(NOT KWCommonPro_INSTALL_NO_RUNTIME)

IF(NOT KWCommonPro_INSTALL_NO_DOCUMENTATION)
  SET(KWCommonPro_INSTALL_NO_DOCUMENTATION 0)
ENDIF(NOT KWCommonPro_INSTALL_NO_DOCUMENTATION)

SET(KWCommonPro_INSTALL_NO_LIBRARIES)
IF(KWCommonPro_BUILD_SHARED_LIBS)
  IF(KWCommonPro_INSTALL_NO_RUNTIME AND KWCommonPro_INSTALL_NO_DEVELOPMENT)
    SET(KWCommonPro_INSTALL_NO_LIBRARIES 1)
  ENDIF(KWCommonPro_INSTALL_NO_RUNTIME AND KWCommonPro_INSTALL_NO_DEVELOPMENT)
ELSE(KWCommonPro_BUILD_SHARED_LIBS)
  IF(KWCommonPro_INSTALL_NO_DEVELOPMENT)
    SET(KWCommonPro_INSTALL_NO_LIBRARIES 1)
  ENDIF(KWCommonPro_INSTALL_NO_DEVELOPMENT)
ENDIF(KWCommonPro_BUILD_SHARED_LIBS)

# --------------------------------------------------------------------------
# Sources

SET(KWCommonPro_SRCS
  vtkAnalyzeReader.cxx
  vtkCellLabelAnnotation.cxx
  vtkContourSegmentationFilter.cxx
  vtkContourStatistics.cxx
  vtkPlanarPolyDataToImageStencil.cxx
  vtkContourToImageStencil.cxx
  vtkDICOMCollector.cxx
  vtkDICOMCollectorOptions.cxx
  vtkDICOMReader.cxx
  vtkGESignaReader3D.cxx
  vtkGPXReader.cxx
  vtkGenericMathUtilities.cxx
  vtkImageStencilDataFlip.cxx
  vtkKWColorImageConversionFilter.cxx
  vtkKWExtractImageIsosurfaceCells.cxx
  vtkKWImageMapToWindowLevelColors.cxx
  vtkKWOrientationFilter.cxx
  vtkLSMReader.cxx
  vtkOpenGLSmoothPolyDataMapper.cxx
  vtkPICReader.cxx
  vtkSTKReader.cxx
  vtkScalarsPassThroughFilter.cxx
  vtkStencilProjectionImageFilter.cxx
  )

IF(VTK_USE_RENDERING)
  SET(KWCommonPro_SRCS ${KWCommonPro_SRCS}
    vtkBezierPatch.cxx
    vtkBoundingBoxAnnotation.cxx
    vtkCardinalSplinePatch.cxx
    vtkIrregularSplineSurfaceWidget.cxx
    vtkKWContourWidget.cxx
    vtkKWDistanceWidget.cxx
    vtkImageActorPointHandleRepresentation3D.cxx
    vtkKWAngleWidget.cxx
    vtkKWBiDimensionalWidget.cxx
    vtkKWCaptionWidget.cxx
    vtkRegularSplineSurfaceWidget.cxx
    vtkSideAnnotation.cxx
    vtkSplineSurface2DWidget.cxx
    vtkSplineSurfaceWidget.cxx
    vtkSubdivisionSplineSurfaceWidget.cxx
    )
  SET_SOURCE_FILES_PROPERTIES(
    vtkBezierPatch.cxx
    vtkBoundingBoxAnnotation.cxx
    vtkCardinalSplinePatch.cxx
    vtkIrregularSplineSurfaceWidget.cxx
    vtkRegularSplineSurfaceWidget.cxx
    vtkSideAnnotation.cxx
    vtkSplineSurface2DWidget.cxx
    vtkSplineSurfaceWidget.cxx
    vtkSubdivisionSplineSurfaceWidget.cxx
    WRAP_EXCLUDE
    ) 
ENDIF(VTK_USE_RENDERING)

IF(KWCommonPro_USE_CTNLIB AND NOT KWCommonPro_USE_GDCM)
  # JPEG12 support has been removed in favor of GDCM's own JPEG12
  #SET(KWCommonPro_SRCS ${KWCommonPro_SRCS} vtkJPEG12Reader.cxx)
ENDIF(KWCommonPro_USE_CTNLIB AND NOT KWCommonPro_USE_GDCM)

SET_SOURCE_FILES_PROPERTIES(
  vtkDICOMCollector.cxx
  vtkDICOMReader.cxx
  PROPERTIES COMPILE_FLAGS -DHAVE_CMAKE_CONFIG_H)

SET(default_val 1)
IF(DEFINED KWCommonPro_USE_XML_RW_DEFAULT)
  SET(default_val ${KWCommonPro_USE_XML_RW_DEFAULT})
ENDIF(DEFINED KWCommonPro_USE_XML_RW_DEFAULT)
OPTION(KWCommonPro_USE_XML_RW
  "Build KWCommonPro XML Readers/Writers." ${default_val})
MARK_AS_ADVANCED(KWCommonPro_USE_XML_RW)

IF(KWCommonPro_USE_XML_RW)
  SET(KWCommonPro_XML_SRCS
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLAbstractWidgetReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLAbstractWidgetWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLActor2DReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLActor2DWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLActorReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLActorWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLAngleRepresentationReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLAngleRepresentationWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLAxisActor2DReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLAxisActor2DWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLBiDimensionalRepresentation2DReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLBiDimensionalRepresentation2DWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLBorderRepresentationReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLBorderRepresentationWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLCameraReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLCameraWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLCaptionActor2DReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLCaptionActor2DWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLCaptionRepresentationReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLCaptionRepresentationWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLCaptionWidgetReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLCaptionWidgetWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLColorTransferFunctionReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLColorTransferFunctionWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLContourRepresentationReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLContourRepresentationWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLCornerAnnotationReader.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLCornerAnnotationWriter.cxx
    ${KWCommonPro_SOURCE_DIR}/XML/vtkXMLDistanceRepresentationReader.cxx

=== VolViewLibraries/KWVolView/CMakeLists.txt ===
##=========================================================================
## 
##   Copyright (c) Kitware, Inc.
##   All rights reserved.
##   See Copyright.txt or http://www.kitware.com/VolViewCopyright.htm for details.
## 
##      This software is distributed WITHOUT ANY WARRANTY; without even
##      the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##      PURPOSE.  See the above copyright notice for more information.
## 
##=========================================================================
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)


PROJECT(KWVolView)

INCLUDE_REGULAR_EXPRESSION("^.*$")

# --------------------------------------------------------------------------
# To use this library in a larger project you will need to SUBDIR into this
# directory so that it gets built and then you will use the following variables
# in your CMakeLists files to get the proper include paths and libraries

SET(KWVolView_INCLUDE_PATH 
  "${CMAKE_CURRENT_SOURCE_DIR}/Core;${CMAKE_CURRENT_SOURCE_DIR}/DataItems;${CMAKE_CURRENT_SOURCE_DIR}/Features;${CMAKE_CURRENT_SOURCE_DIR}/RemoteIO;${CMAKE_CURRENT_SOURCE_DIR}/MeasurementTools;${CMAKE_CURRENT_SOURCE_DIR}/SegmentationTools;${CMAKE_CURRENT_SOURCE_DIR}/Resources;${CMAKE_CURRENT_SOURCE_DIR}/Plugins;${CMAKE_CURRENT_SOURCE_DIR}/AdvancedAlgorithms;${CMAKE_CURRENT_BINARY_DIR}"
  CACHE INTERNAL "include paths for KWVolView"
  )

SET(KWVolView_LIBRARIES KWVolView 
  CACHE INTERNAL "libraries for KWVolView")

# You will also need to define a value for the following variables:
# KWVolView_INSTALL_BIN_DIR            - binary dir (executables)
# KWVolView_INSTALL_LIB_DIR            - library dir (libs)
# KWVolView_INSTALL_DATA_DIR           - share dir (say, examples, data, etc)
# KWVolView_INSTALL_INCLUDE_DIR        - include dir (headers)
# KWVolView_INSTALL_PACKAGE_DIR        - package/export configuration files
# KWVolView_KWWidgetsPro_INSTALL_PACKAGE_DIR - KWWidgetsPro package/export 
# KWVolView_VTKEdge_INSTALL_PACKAGE_DIR - VTKEdge package/export 
# KWVolView_GDCM_INSTALL_PACKAGE_DIR   - GDCM package/export config files
# KWVolView_INSTALL_NO_DEVELOPMENT     - do not install development files
# KWVolView_INSTALL_NO_RUNTIME         - do not install runtime files
# KWVolView_INSTALL_NO_DOCUMENTATION   - do not install documentation files
# --------------------------------------------------------------------------

# --------------------------------------------------------------------------
# Version

SET(KWVolView_MAJOR_VERSION 1)
SET(KWVolView_MINOR_VERSION 0)

# --------------------------------------------------------------------------
# We need various packages

MACRO(KWVolView_REQUIRE_PACKAGE PACKAGE_NAME)
  IF(NOT ${PACKAGE_NAME}_SOURCE_DIR)
    FIND_PACKAGE(${PACKAGE_NAME} REQUIRED)
    IF(${PACKAGE_NAME}_FOUND)
      INCLUDE(${${PACKAGE_NAME}_USE_FILE})
    ENDIF(${PACKAGE_NAME}_FOUND)
  ENDIF(NOT ${PACKAGE_NAME}_SOURCE_DIR)
ENDMACRO(KWVolView_REQUIRE_PACKAGE PACKAGE_NAME)

# KWWidgetsPro (which brings KWWidgets, KWCommonPro, KWCommon automatically)

KWVolView_REQUIRE_PACKAGE(KWWidgetsPro)

# GDCM

SET(default_val 1)
IF(DEFINED KWVolView_USE_GDCM_DEFAULT)
  SET(default_val ${KWVolView_USE_GDCM_DEFAULT})
ENDIF(DEFINED KWVolView_USE_GDCM_DEFAULT)
OPTION(KWVolView_USE_GDCM 
  "Build KWVolView with GDCM support." ${default_val})
MARK_AS_ADVANCED(KWVolView_USE_GDCM)
IF(KWVolView_USE_GDCM)
  KWVolView_REQUIRE_PACKAGE(GDCM)
  IF(NOT GDCM_VTK)
    MESSAGE(FATAL_ERROR "GDCM_VTK is OFF. Please configure and build GDCM with GDCM_VTK set to ON in order to use GDCM's reader and writer classes for VTK.")
  ENDIF(NOT GDCM_VTK)
ENDIF(KWVolView_USE_GDCM)


# Plugins
OPTION(KWVolView_BUILD_PLUGINS "Build KWVolView with Plugins support." ON)
SET(KWVolView_PLUGINS_USE_SERIES OFF CACHE INTERNAL "")
SET(KWVolView_PLUGINS_USE_SPLINE OFF CACHE INTERNAL "")
SET(KWVolView_PLUGINS_USE_MARKER ON  CACHE INTERNAL "")
MARK_AS_ADVANCED(KWVolView_BUILD_PLUGINS)

# VTKEdge

KWVolView_REQUIRE_PACKAGE(VTKEdge)

# Use the lesion sizing toolkit ?

OPTION(KWVolView_USE_LESION_SIZING_KIT
  "Build the Lesion sizing kit into the application. This will add a UI panel for CT lung lesion sizing. It will require you to specify the inlcude and library path for the lesion sizing toolkit."  ON )
MARK_AS_ADVANCED(KWVolView_USE_LESION_SIZING_KIT)
IF(KWVolView_USE_LESION_SIZING_KIT)
  FIND_PATH(LesionSizingKit_Sandbox_SOURCE_DIR 
    itkLesionSegmentationMethod.h
    PATHS ${VolViewPlatform_PARENT_DIR}/VolViewExternalLibraries/LesionSizingKit/Sandbox/Source 
    DOC "Path to the LesionSizing toolkit Sandbox source dir.")
  MARK_AS_ADVANCED(LesionSizingKit_Sandbox_SOURCE_DIR)
ENDIF(KWVolView_USE_LESION_SIZING_KIT)


# ITK

IF(KWVolView_USE_LESION_SIZING_KIT)
  IF(NOT ITK_SOURCE_DIR)
    FIND_PACKAGE(ITK REQUIRED)
    IF(ITK_FOUND)
      INCLUDE(${ITK_USE_FILE})
    ENDIF(ITK_FOUND)
  ELSE(NOT ITK_SOURCE_DIR)
    INCLUDE(${ITK_SOURCE_DIR}/Utilities/itkThirdParty.cmake)
    INCLUDE(${ITK_SOURCE_DIR}/itkIncludeDirectories.cmake)
    INCLUDE_DIRECTORIES(
      ${ITK_INCLUDE_DIRS_BUILD_TREE}
      ${ITK_INCLUDE_DIRS_BUILD_TREE_CXX}
      ${ITK_INCLUDE_DIRS_SYSTEM}
      )
  ENDIF(NOT ITK_SOURCE_DIR)
ENDIF(KWVolView_USE_LESION_SIZING_KIT)

# --------------------------------------------------------------------------
# Output directories

IF(NOT LIBRARY_OUTPUT_PATH)
  SET(LIBRARY_OUTPUT_PATH ${KWVolView_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
SET(KWVolView_LIBRARY_DIRS ${LIBRARY_OUTPUT_PATH})
SET(KWVolView_RUNTIME_DIRS ${LIBRARY_OUTPUT_PATH})

IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET(EXECUTABLE_OUTPUT_PATH ${KWVolView_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)

# --------------------------------------------------------------------------
# Some flags

INCLUDE_REGULAR_EXPRESSION("^(vtk|kw|icons).*$")
SET(CMAKE_C_FLAGS "${CMAKE_ANSI_CFLAGS} ${CMAKE_C_FLAGS}")
IF(CMAKE_COMPILER_2005)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
ENDIF(CMAKE_COMPILER_2005)

SET(BUILD_SHARED_LIBS ${VTK_BUILD_SHARED_LIBS})
SET(KWVolView_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

SET(KWVolView_CMAKE_DIR "${KWVolView_SOURCE_DIR}/CMake")
SUBDIRS(CMake)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${KWVolView_CMAKE_DIR}")

SET(KWVolView_CONFIGURATION_TYPES ${CMAKE_CONFIGURATION_TYPES})

MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)

SET(KWVolView_TEMPLATES_DIR ${KWVolView_SOURCE_DIR}/Templates)

# --------------------------------------------------------------------------
# Install directories

IF(NOT KWVolView_INSTALL_BIN_DIR)
  SET(KWVolView_INSTALL_BIN_DIR "/bin")
ENDIF(NOT KWVolView_INSTALL_BIN_DIR)

IF(NOT KWVolView_INSTALL_LIB_DIR)
  SET(KWVolView_INSTALL_LIB_DIR "/lib/${PROJECT_NAME}")
ENDIF(NOT KWVolView_INSTALL_LIB_DIR)

IF(NOT KWVolView_INSTALL_DATA_DIR)
  SET(KWVolView_INSTALL_DATA_DIR "/share/${PROJECT_NAME}"
    CACHE INTERNAL "")
ENDIF(NOT KWVolView_INSTALL_DATA_DIR)

IF(NOT KWVolView_INSTALL_INCLUDE_DIR)
  SET(KWVolView_INSTALL_INCLUDE_DIR "/include/${PROJECT_NAME}")
ENDIF(NOT KWVolView_INSTALL_INCLUDE_DIR)

IF(NOT KWVolView_INSTALL_PACKAGE_DIR)
  SET(KWVolView_INSTALL_PACKAGE_DIR ${KWVolView_INSTALL_LIB_DIR}
    CACHE INTERNAL "")
ENDIF(NOT KWVolView_INSTALL_PACKAGE_DIR)

IF(NOT KWVolView_KWWidgetsPro_INSTALL_PACKAGE_DIR)
  SET(KWVolView_KWWidgetsPro_INSTALL_PACKAGE_DIR 
    ${KWWidgetsPro_INSTALL_PACKAGE_DIR})
ENDIF(NOT KWVolView_KWWidgetsPro_INSTALL_PACKAGE_DIR)

IF(NOT KWVolView_VTKEdge_INSTALL_PACKAGE_DIR)
  SET(KWVolView_VTKEdge_INSTALL_PACKAGE_DIR 
    ${VTKEdge_INSTALL_PACKAGE_DIR})
ENDIF(NOT KWVolView_VTKEdge_INSTALL_PACKAGE_DIR)

IF(NOT KWVolView_GDCM_INSTALL_PACKAGE_DIR)
  SET(KWVolView_GDCM_INSTALL_PACKAGE_DIR ${GDCM_INSTALL_PACKAGE_DIR})
ENDIF(NOT KWVolView_GDCM_INSTALL_PACKAGE_DIR)

IF(NOT KWVolView_INSTALL_NO_DEVELOPMENT)
  SET(KWVolView_INSTALL_NO_DEVELOPMENT 0)
ENDIF(NOT KWVolView_INSTALL_NO_DEVELOPMENT)

IF(NOT KWVolView_INSTALL_NO_RUNTIME)
  SET(KWVolView_INSTALL_NO_RUNTIME 0)
ENDIF(NOT KWVolView_INSTALL_NO_RUNTIME)

IF(NOT KWVolView_INSTALL_NO_DOCUMENTATION)
  SET(KWVolView_INSTALL_NO_DOCUMENTATION 0)
ENDIF(NOT KWVolView_INSTALL_NO_DOCUMENTATION)

SET(KWVolView_INSTALL_NO_LIBRARIES)
IF(KWVolView_BUILD_SHARED_LIBS)
  IF(KWVolView_INSTALL_NO_RUNTIME AND KWVolView_INSTALL_NO_DEVELOPMENT)
    SET(KWVolView_INSTALL_NO_LIBRARIES 1)
  ENDIF(KWVolView_INSTALL_NO_RUNTIME AND KWVolView_INSTALL_NO_DEVELOPMENT)
ELSE(KWVolView_BUILD_SHARED_LIBS)
  IF(KWVolView_INSTALL_NO_DEVELOPMENT)
    SET(KWVolView_INSTALL_NO_LIBRARIES 1)
  ENDIF(KWVolView_INSTALL_NO_DEVELOPMENT)
ENDIF(KWVolView_BUILD_SHARED_LIBS)

# --------------------------------------------------------------------------
# Sources: Core

SET(KWVolView_Core_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVApplication.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVApplicationSettingsInterface.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVApplicationSettingsInterfaceBase.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVSaveDialog.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVSaveFiducialsDialog.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVSaveVolume.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVSaveFiducials.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVSelectionFrame.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVSelectionFrameLayoutManager.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVSnapshotPresetSelector.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVUserInterfacePanel.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVWindow.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/vtkVVWindowBase.cxx
  )
SET(KWVolView_Core_XML_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/XML/vtkXMLVVWindowBaseReader.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/XML/vtkXMLVVWindowBaseWriter.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/XML/vtkXMLVVApplicationReader.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/XML/vtkXMLVVApplicationWriter.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/XML/vtkXMLVVSelectionFrameLayoutManagerReader.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/XML/vtkXMLVVSelectionFrameLayoutManagerWriter.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/XML/vtkXMLVVSelectionFrameReader.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/Core/XML/vtkXMLVVSelectionFrameWriter.cxx
  )
SET(KWVolView_SRCS 
  ${KWVolView_SRCS} ${KWVolView_Core_SRCS} ${KWVolView_Core_XML_SRCS})

SET_SOURCE_FILES_PROPERTIES(
  ${KWVolView_Core_XML_SRCS}
  WRAP_EXCLUDE
  )

# --------------------------------------------------------------------------
# Sources: Data Items

SET(KWVolView_DataItems_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVDataItem.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVDataItemVolume.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVDataItemVolumeContour.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVDataItemVolumeContourCollection.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkRECISTCalculator.cxx 
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVLODDataItemVolumeHelper.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVDataItemPool.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVFileInstance.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVFileInstancePool.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVFileAuthenticator.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVMD5FileAuthenticator.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVSnapshot.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/vtkVVSnapshotPool.cxx
  )
SET(KWVolView_DataItems_XML_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/XML/vtkXMLVVDataItemPoolReader.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/XML/vtkXMLVVDataItemPoolWriter.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/XML/vtkXMLVVDataItemReader.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/XML/vtkXMLVVDataItemVolumeReader.cxx
  ${CMAKE_CURRENT_SOURCE_DIR}/DataItems/XML/vtkXMLVVDataItemVolumeWriter.cxx

=== VolViewLibraries/KWWidgetsPro/CMakeLists.txt ===
##=========================================================================
## 
##   Copyright (c) Kitware, Inc.
##   All rights reserved.
##   See Copyright.txt or http://www.kitware.com/VolViewCopyright.htm for details.
## 
##      This software is distributed WITHOUT ANY WARRANTY; without even
##      the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##      PURPOSE.  See the above copyright notice for more information.
## 
##=========================================================================
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(KWWidgetsPro)

# --------------------------------------------------------------------------
# To use this library in a larger project you will need to SUBDIR into this
# directory so that it gets built and then you will use the following variables
# in your CMakeLists files to get the proper include paths and libraries

SET(KWWidgetsPro_INCLUDE_PATH 
  "${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_BINARY_DIR}"
  CACHE INTERNAL "include paths for KWWidgetsPro"
  )

SET(KWWidgetsPro_LIBRARIES KWWidgetsPro
  CACHE INTERNAL "libraries for KWWidgetsPro")

# You will also need to define a value for the following variables:
# KWWidgetsPro_INSTALL_BIN_DIR           - binary dir (executables)
# KWWidgetsPro_INSTALL_LIB_DIR           - library dir (libs)
# KWWidgetsPro_INSTALL_DATA_DIR          - share dir (say, examples, data, etc)
# KWWidgetsPro_INSTALL_INCLUDE_DIR       - include dir (headers)
# KWWidgetsPro_INSTALL_PACKAGE_DIR       - package/export configuration files
# KWWidgetsPro_KWCommonPro_INSTALL_PACKAGE_DIR - KWCommonPro package/export
# KWWidgetsPro_KWWidgets_INSTALL_PACKAGE_DIR   - KWWidgets package/export
# KWWidgetsPro_INSTALL_NO_DEVELOPMENT    - do not install development files
# KWWidgetsPro_INSTALL_NO_RUNTIME        - do not install runtime files
# KWWidgetsPro_INSTALL_NO_DOCUMENTATION  - do not install documentation files
# --------------------------------------------------------------------------

# --------------------------------------------------------------------------
# Version

SET(KWWidgetsPro_MAJOR_VERSION 1)
SET(KWWidgetsPro_MINOR_VERSION 0)

# --------------------------------------------------------------------------
# We need various packages

MACRO(KWWidgetsPro_REQUIRE_PACKAGE PACKAGE_NAME)
  IF(NOT ${PACKAGE_NAME}_SOURCE_DIR)
    FIND_PACKAGE(${PACKAGE_NAME} REQUIRED)
    IF(${PACKAGE_NAME}_FOUND)
      INCLUDE(${${PACKAGE_NAME}_USE_FILE})
    ENDIF(${PACKAGE_NAME}_FOUND)
  ENDIF(NOT ${PACKAGE_NAME}_SOURCE_DIR)
ENDMACRO(KWWidgetsPro_REQUIRE_PACKAGE PACKAGE_NAME)

# KWWidgets

KWWidgetsPro_REQUIRE_PACKAGE(KWWidgets)

# KWCommonPro (which brings KWCommon and VTK automatically) 
# This package brings pretty much *everything* in VTK. Therefore, if
# KWWidgets was built with Core support only (UI only, no VTK widget), try
# not to use KWCommonPro either.

IF(KWWidgets_BUILD_VTK_WIDGETS)
  KWWidgetsPro_REQUIRE_PACKAGE(KWCommonPro)
ENDIF(KWWidgets_BUILD_VTK_WIDGETS)

# VTKEdge

KWWidgetsPro_REQUIRE_PACKAGE(VTKEdge)

# --------------------------------------------------------------------------
# Output directories

IF(NOT LIBRARY_OUTPUT_PATH)
  SET(LIBRARY_OUTPUT_PATH ${KWWidgetsPro_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
SET(KWWidgetsPro_LIBRARY_DIRS ${LIBRARY_OUTPUT_PATH})
SET(KWWidgetsPro_RUNTIME_DIRS ${LIBRARY_OUTPUT_PATH})

IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET(EXECUTABLE_OUTPUT_PATH ${KWWidgetsPro_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)

# --------------------------------------------------------------------------
# Some flags

INCLUDE_REGULAR_EXPRESSION("^(vtk|kw|icons).*$")
SET(CMAKE_C_FLAGS "${CMAKE_ANSI_CFLAGS} ${CMAKE_C_FLAGS}")
IF(CMAKE_COMPILER_2005)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
ENDIF(CMAKE_COMPILER_2005)

SET(BUILD_SHARED_LIBS ${VTK_BUILD_SHARED_LIBS})
SET(KWWidgetsPro_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

SET(KWWidgetsPro_CMAKE_DIR "${KWWidgetsPro_SOURCE_DIR}/CMake")
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${KWWidgetsPro_CMAKE_DIR}")

SET(KWWidgetsPro_CONFIGURATION_TYPES ${CMAKE_CONFIGURATION_TYPES})

MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)

# --------------------------------------------------------------------------
# Install directories

IF(NOT KWWidgetsPro_INSTALL_BIN_DIR)
  SET(KWWidgetsPro_INSTALL_BIN_DIR "/bin")
ENDIF(NOT KWWidgetsPro_INSTALL_BIN_DIR)

IF(NOT KWWidgetsPro_INSTALL_LIB_DIR)
  SET(KWWidgetsPro_INSTALL_LIB_DIR "/lib/${PROJECT_NAME}")
ENDIF(NOT KWWidgetsPro_INSTALL_LIB_DIR)

IF(NOT KWWidgetsPro_INSTALL_DATA_DIR)
  SET(KWWidgetsPro_INSTALL_DATA_DIR "/share/${PROJECT_NAME}"
    CACHE INTERNAL "")
ENDIF(NOT KWWidgetsPro_INSTALL_DATA_DIR)

IF(NOT KWWidgetsPro_INSTALL_INCLUDE_DIR)
  SET(KWWidgetsPro_INSTALL_INCLUDE_DIR "/include/${PROJECT_NAME}")
ENDIF(NOT KWWidgetsPro_INSTALL_INCLUDE_DIR)

IF(NOT KWWidgetsPro_INSTALL_PACKAGE_DIR)
  SET(KWWidgetsPro_INSTALL_PACKAGE_DIR ${KWWidgetsPro_INSTALL_LIB_DIR}
    CACHE INTERNAL "")
ENDIF(NOT KWWidgetsPro_INSTALL_PACKAGE_DIR)

IF(NOT KWWidgetsPro_KWCommonPro_INSTALL_PACKAGE_DIR)
  SET(KWWidgetsPro_KWCommonPro_INSTALL_PACKAGE_DIR 
    ${KWCommonPro_INSTALL_PACKAGE_DIR})
ENDIF(NOT KWWidgetsPro_KWCommonPro_INSTALL_PACKAGE_DIR)

IF(NOT KWWidgetsPro_KWWidgets_INSTALL_PACKAGE_DIR)
  SET(KWWidgetsPro_KWWidgets_INSTALL_PACKAGE_DIR 
    ${KWWidgets_INSTALL_PACKAGE_DIR})
ENDIF(NOT KWWidgetsPro_KWWidgets_INSTALL_PACKAGE_DIR)

IF(NOT KWWidgetsPro_INSTALL_NO_DEVELOPMENT)
  SET(KWWidgetsPro_INSTALL_NO_DEVELOPMENT 0)
ENDIF(NOT KWWidgetsPro_INSTALL_NO_DEVELOPMENT)

IF(NOT KWWidgetsPro_INSTALL_NO_RUNTIME)
  SET(KWWidgetsPro_INSTALL_NO_RUNTIME 0)
ENDIF(NOT KWWidgetsPro_INSTALL_NO_RUNTIME)

IF(NOT KWWidgetsPro_INSTALL_NO_DOCUMENTATION)
  SET(KWWidgetsPro_INSTALL_NO_DOCUMENTATION 0)
ENDIF(NOT KWWidgetsPro_INSTALL_NO_DOCUMENTATION)

SET(KWWidgetsPro_INSTALL_NO_LIBRARIES)
IF(KWWidgetsPro_BUILD_SHARED_LIBS)
  IF(KWWidgetsPro_INSTALL_NO_RUNTIME AND KWWidgetsPro_INSTALL_NO_DEVELOPMENT)
    SET(KWWidgetsPro_INSTALL_NO_LIBRARIES 1)
  ENDIF(KWWidgetsPro_INSTALL_NO_RUNTIME AND KWWidgetsPro_INSTALL_NO_DEVELOPMENT)
ELSE(KWWidgetsPro_BUILD_SHARED_LIBS)
  IF(KWWidgetsPro_INSTALL_NO_DEVELOPMENT)
    SET(KWWidgetsPro_INSTALL_NO_LIBRARIES 1)
  ENDIF(KWWidgetsPro_INSTALL_NO_DEVELOPMENT)
ENDIF(KWWidgetsPro_BUILD_SHARED_LIBS)

# --------------------------------------------------------------------------
# Sources

SET(KWWidgetsPro_SRCS
  vtkKWApplicationPro.cxx
  vtkKWApplicationSettingsInterfacePro.cxx
  vtkKWMouseBindings.cxx
  vtkKWSegmentedProgressGauge.cxx
  vtkKWWizard.cxx
  ) 

IF(KWWidgets_BUILD_VTK_WIDGETS)
  SET(KWWidgetsPro_SRCS ${KWWidgetsPro_SRCS}
    vtk3DCursorAnnotation.cxx
    vtkKW2DRenderWidget.cxx
    vtkKW2DSplineSurfacesWidget.cxx
    vtkKW3DMarkersWidget.cxx
    vtkKW3DSplineCurvesWidget.cxx
    vtkKW3DSplineSurfacesWidget.cxx
    vtkKW3DWidget.cxx
    vtkKWCameraLightWidget.cxx
    vtkKWCornerAnnotationEditorPro.cxx
    vtkKWCroppingRegionsWidget.cxx
    vtkKWCursorWidget.cxx
    vtkKWHeaderAnnotationEditorPro.cxx
    vtkKWImageWidget.cxx
    vtkKWInteractorStyle2DView.cxx
    vtkKWInteractorStyleEventMap.cxx
    vtkKWInteractorStyleImageView.cxx
    vtkKWInteractorStyleLightboxView.cxx
    vtkKWInteractorStyleView.cxx
    vtkKWInteractorStyleVolumeView.cxx
    vtkKWLightboxWidget.cxx
    vtkKWMarker2D.cxx
    vtkKWOrientationWidget.cxx
    vtkKWProbeImageWidget.cxx
    vtkKWProgressCommand.cxx
    vtkKWRenderWidgetPro.cxx
    vtkKWScalarBarAnnotationPro.cxx
    vtkKWScalarBarWidget.cxx
    vtkKWScaleBarWidget.cxx
    vtkKWSurfaceMaterialPropertyWidgetPro.cxx
    vtkKWVolumeMaterialPropertyWidgetPro.cxx
    vtkKWVolumePropertyWidgetPro.cxx
    vtkKWVolumeWidget.cxx
    vtkKWXYPlotDialog.cxx
    vtkSurfaceAnnotation.cxx
    ) 
  IF(KWCommonPro_USE_XML_RW)
  SET(KWWidgetsPro_SRCS ${KWWidgetsPro_SRCS}
    vtkKWOpenWizard.cxx
    vtkKWOpenFileHelper.cxx
    vtkKWOpenFileProperties.cxx
    )
  ENDIF(KWCommonPro_USE_XML_RW)
ENDIF(KWWidgets_BUILD_VTK_WIDGETS)

SET_SOURCE_FILES_PROPERTIES(
  vtkKW2DRenderWidget.cxx
  vtkKW3DWidget.cxx
  vtkKWRenderWidgetPro.cxx
  ABSTRACT
  ) 

SET_SOURCE_FILES_PROPERTIES(
  vtk3DCursorAnnotation.cxx
  vtkKW2DSplineSurfacesWidget.cxx
  vtkKW3DMarkersWidget.cxx
  vtkKW3DSplineCurvesWidget.cxx
  vtkKW3DSplineSurfacesWidget.cxx
  vtkKW3DWidget.cxx
  vtkKWCroppingRegionsWidget.cxx
  vtkKWCursorWidget.cxx
  vtkKWInteractorStyle2DView.cxx
  vtkKWInteractorStyleEventMap.cxx
  vtkKWInteractorStyleImageView.cxx
  vtkKWInteractorStyleLightboxView.cxx
  vtkKWInteractorStyleView.cxx
  vtkKWInteractorStyleVolumeView.cxx
  vtkKWMarker2D.cxx
  vtkKWOrientationWidget.cxx
  vtkKWProgressCommand.cxx
  vtkKWScalarBarWidget.cxx
  vtkKWScaleBarWidget.cxx
  vtkSurfaceAnnotation.cxx
  WRAP_EXCLUDE
  ) 

IF(KWCommonPro_USE_XML_RW)
  SET(KWWidgetsPro_XML_SRCS 
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXML3DCursorAnnotationReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXML3DCursorAnnotationWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKW2DRenderWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKW2DRenderWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKW3DMarkersWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKW3DMarkersWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKW3DSplineSurfacesWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKW3DSplineSurfacesWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKW3DWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKW3DWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWApplicationReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWApplicationWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWCroppingRegionsWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWCroppingRegionsWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWCursorWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWCursorWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWEventMapReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWEventMapWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWIconReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWIconWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWImageWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWImageWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWLightboxWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWLightboxWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWMarker2DReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWMarker2DWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWOpenFilePropertiesReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWOpenFilePropertiesWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWOrientationWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWOrientationWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWProbeImageWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWProbeImageWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWRenderWidgetProReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWRenderWidgetProWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWRenderWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWRenderWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWScaleBarWidgetReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWScaleBarWidgetWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWSelectionFrameReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWSelectionFrameWriter.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWUserInterfaceManagerNotebookReader.cxx
    ${KWWidgetsPro_SOURCE_DIR}/XML/vtkXMLKWUserInterfaceManagerNotebookWriter.cxx

=== VolViewApplications/Kitware/VolView/CMakeLists.txt ===
##=========================================================================
## 
##   Copyright (c) Kitware, Inc.
##   All rights reserved.
##   See Copyright.txt or http://www.kitware.com/VolViewCopyright.htm for details.
## 
##      This software is distributed WITHOUT ANY WARRANTY; without even
##      the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##      PURPOSE.  See the above copyright notice for more information.
## 
##=========================================================================
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(VolView)

# --------------------------------------------------------------------------
# We need VolViewLibraries

FIND_PACKAGE(VolViewLibraries REQUIRED)
INCLUDE(${VolViewLibraries_USE_FILE})

# --------------------------------------------------------------------------
# Create the executable

SET(BUILD_VolView ON)
INCLUDE("${KWVolView_CMAKE_DIR}/KWVolViewCreateExecutableMacros.cmake")
KWVolView_CREATE_EXECUTABLE(
  APPLICATION_NAME    "VolView"
  EXECUTABLE_NAME     "VolView"
  MAJOR_VERSION       3
  MINOR_VERSION       4
  RELEASE_NAME        ""
  LICENSE_FILE        "${VolViewApplications_SOURCE_DIR}/License.txt"
  SUPPORT_TRIAL_MODE  1
  SUPPORT_TESTING     1
  SUPPORT_TESTING_GUI 1
  SUPPORT_PLUGINS     1
  APPLICATION_CLASS_NAME "vtkVolViewApplication"
  EXTRA_SOURCES       "vtkVolViewApplication.cxx"
  INSTALL_DEFAULT_DATA_SAMPLES 1
  DOCUMENTATION_FILE  "Documentation/VolView 3 User Manual.pdf"
)

=== VolViewExternalLibraries/LesionSizingKit/Sandbox/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(LesionSizingKitSandbox)

FIND_PACKAGE(ITK REQUIRED)
INCLUDE(${ITK_USE_FILE})


OPTION(ITK_USE_MULTI_PHASE_FRAMEWORK "Enable multi-phase level sets" OFF)

OPTION(LSTK_SANDBOX_BUILD_REPORTS "Build Lesion Sizing Toolkit Sandbox with LaTeX reports." OFF)

OPTION(LSTK_SANDBOX_USE_VTK "Build visualization helper tools." OFF)

IF( LSTK_SANDBOX_BUILD_REPORTS AND NOT LSTK_SANDBOX_USE_VTK )
  MESSAGE(FATAL_ERROR "In order to build the Report you MUST activate the option LSTK_SANDBOX_USE_VTK")
ENDIF( LSTK_SANDBOX_BUILD_REPORTS AND NOT LSTK_SANDBOX_USE_VTK )


ENABLE_TESTING()
INCLUDE(CTest)

INCLUDE_DIRECTORIES(
  ${LesionSizingKitSandbox_SOURCE_DIR}/Source
  )

IF (ITK_USE_MULTI_PHASE_FRAMEWORK)
  ADD_SUBDIRECTORY(Source)
ENDIF( ITK_USE_MULTI_PHASE_FRAMEWORK )
ADD_SUBDIRECTORY(Utilities)
IF(BUILD_TESTING)
  ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

INCLUDE(${LesionSizingKitSandbox_SOURCE_DIR}/Utilities/KWStyle/KWStyle.cmake)

IF(LSTK_SANDBOX_BUILD_REPORTS)
  ADD_SUBDIRECTORY(Documents)
ENDIF(LSTK_SANDBOX_BUILD_REPORTS)

=== VolViewExternalLibraries/LesionSizingKit/Toolkit/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(LesionSizingToolkit)

FIND_PACKAGE(ITK REQUIRED)
INCLUDE(${ITK_USE_FILE})

SET(EXECUTABLE_OUTPUT_PATH ${LesionSizingToolkit_BINARY_DIR}/bin CACHE INTERNAL "Where to put the executables") 
SET(LIBRARY_OUTPUT_PATH ${LesionSizingToolkit_BINARY_DIR}/bin CACHE INTERNAL "Where to put the libraries") 

ENABLE_TESTING()
INCLUDE(CTest)

INCLUDE_DIRECTORIES(
  ${LesionSizingToolkit_SOURCE_DIR}/Source
  )

ADD_SUBDIRECTORY(Source)
IF(BUILD_TESTING)
  ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)
ADD_SUBDIRECTORY(Examples)

INCLUDE(${LesionSizingToolkit_SOURCE_DIR}/Utilities/KWStyle/KWStyle.cmake)

=== debian/changelog ===
volview (3.4-3ubuntu1) raring; urgency=low

  * Fixed FTBFS (hardcoded Tcl and Tk locations in a CMakeLists.txt).
  * Made swab(3) available to avoid causing FTBFS on amd64 due to
    implicit function declaration.

 -- Daniel T Chen <crimsun@ubuntu.com>  Fri, 12 Apr 2013 16:29:36 -0400

volview (3.4-3build1) quantal; urgency=low

  * Rebuild for libgdcm2.2

 -- Michael Terry <mterry@ubuntu.com>  Mon, 23 Jul 2012 17:58:02 -0400

volview (3.4-3) unstable; urgency=low

  * Need to remove quote from CFLAGS (MIPS compilation)
  * fix compilation issues introduced by -fPIC
  * Bump Std-Vers to 3.9.3, no changes needed
  * Use my @d.o alias.
  * Remove DMUA flag
  * Use hardening flags. Closes: #665637

 -- Mathieu Malaterre <malat@debian.org>  Fri, 30 Mar 2012 17:31:14 +0200

volview (3.4-2) unstable; urgency=low

  * Use any curl.h provider
  * Make sure to use vtkedge 0.2 and above
  * Fix mipsel compilation. Closes: #658273
  * Use hardening flags

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 01 Feb 2012 21:14:28 +0100

volview (3.4-1) unstable; urgency=low

  * Initial release (Closes: #640511)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Fri, 30 Dec 2011 09:41:46 +0100

=== debian/control ===
Source: volview
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: debhelper (>= 8), cmake (>= 2.8.2),
 libinsighttoolkit3-dev (>= 3.20), libvtk5-dev (>= 5.8.0), libfftw3-dev,
 libgdcm2-dev (>= 2.0.18), libkwwidgets1-dev, tcl8.5-dev, tk8.5-dev,
 libavformat-dev, libvtkedge-dev (>= 0.2), libcurl4-gnutls-dev | libcurl4-dev, libtar-dev
Standards-Version: 3.9.3
Homepage: http://www.kitware.com/products/volview.html
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/volview/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/volview/trunk/

Package: volview
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Advanced volume visualization tool
 VolView is an intuitive, interactive system for volume visualization that
 allows researchers to quickly explore and analyze complex 3D medical or
 scientific data on Windows, Mac and Linux computers. Users can easily load and
 interactively explore datasets using 2D and 3D display methods and tools. 3D
 tools include volume rendering, maximum intensity projections, and oblique
 reformatting. The ability to save an entire visualization session allows users
 to easily stop and start sessions. Advanced users can perform custom data
 processing using a simple plug-in API.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
# http://bugs.debian.org/653916
CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

DEB_HOST_ARCH:=$(shell dpkg-architecture -qDEB_HOST_ARCH)
# http://bugs.debian.org/658273
CFLAGS   += -fPIC
CXXFLAGS += -fPIC
LDFLAGS  += -Wl,--as-needed

%:
	dh $@  --parallel --sourcedirectory=VolViewPlatformComplete

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo

override_dh_compress:
	dh_compress -X.pdf

override_dh_installdocs:
	# I could not figure out how to handle space in the filename with dh_installdocs
	#echo "$(DEB_BUILD_GNU_TYPE)"
	mkdir -p debian/volview/usr/share/doc/volview/
	mv "debian/volview/usr/doc/VolView 3 User Manual.pdf" debian/volview/usr/share/doc/volview/VolView3UserManual.pdf
	rmdir debian/volview/usr/doc
	dh_installdocs

override_dh_auto_install:
	dh_auto_install
	mv debian/volview/usr/bin/Plugins debian/volview/usr/lib/VolView
	mv debian/volview/usr/bin/VolView debian/volview/usr/lib/VolView

get-orig-source:
	./debian/get-orig-source

=== debian/watch ===
version=3
http://www.kitware.com/products/vvdownload.html \
http://www.kitware.com/VolView/files/VolView-([\d\.]+)-Linux-x86_64.sh
